#----------------------------------------------------
# Vermessungstechnische Berechnungen
# Version 1.01
#----------------------------------------------------
#Autor: (copyright) 2023  Norbert Fuhrmann, Kerpen (All Rights Reserved)

from tkinter import*
import math, decimal, tkinter.messagebox, os, sys

global android
android = True

#--------------------------------------------------------------------

class Ortho():    #01

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.6619772367581343
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400. : t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',12))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = "Orthogonale\n und polare Elemente ", fg='blue', font=('Arial',10))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.tanfangspunkt= Label(self.frame2, text = 'Anfangspunkt (UTM)', width=18, font=('Arial',10))
        self.tanfangspunkt.pack
        self.tanfangspunkt.grid(column=0, columnspan=4, row=0)
        self.tya = Label(self.frame2, text = ' y\u2090', font=('Arial',10))
        self.tya.pack
        self.tya.grid(column=0, row=1)
        self.ya = Entry(self.frame2, width=9)
        self.ya.grid(column=1, row=1)
        self.ya.focus()
        self.ya.pack

        self.txa = Label(self.frame2, text = ' x\u2090', font=('Arial',10))
        self.txa.grid(column=2, row=1, pady=4)
        self.txa.pack
        self.xa = Entry(self.frame2, width=9)
        self.xa.grid(column=3, row=1)
        self.xa.pack

        self.tendpunkt= Label(self.frame2, text = 'Endpunkt (UTM)', width=14, font=('Arial',10))    
        self.tendpunkt.grid(column=0, columnspan=2, row=3)
        self.tendpunkt.pack
        self.tnullrichtung= Label(self.frame2, text = '(als Nullrichtung)', width=14, font=('Arial',9), fg=("green"))       
        self.tnullrichtung.grid(column=2, columnspan=2, row=3)
        self.tnullrichtung.pack

        self.tye = Label(self.frame2, text = ' y\u2091', font=('Arial',10))
        self.tye.grid(column=0, row=4)
        self.tye.pack
        self.ye = Entry(self.frame2, width=9)
        self.ye.grid(column=1, row=4)
        self.ye.pack
        self.txe = Label(self.frame2, text = ' x\u2091', font=('Arial',10))
        self.txe.grid(column=2, row=4)
        self.txe.pack
        self.xe = Entry(self.frame2, width=9)
        self.xe.grid(column=3, row=4)
        self.xe.pack

        self.txe2 = Label(self.frame2, text = '\u2500'*45, font=('Arial',4))
        self.txe2.grid(column=0,columnspan=4, row=5)

        self.treduktionsfaktor = Label(self.frame2, text = 'Reduktionsfaktor r' ,width=15, font=('Arial',9))
        self.treduktionsfaktor.grid(column=1, columnspan=2, row=6)
        self.treduktionsfaktor.pack
        self.reduktionsfaktor = Entry(self.frame2, width=9)
        self.reduktionsfaktor.grid(column=3, row=6)
        self.reduktionsfaktor.pack
        self.reduktionsfaktor.insert(0, "1.0")

        self.lab0 = Label(self.fenster, text = 'Def.: Strecke (hor.) \u00D7 r  =  Strecke (UTM)')
        self.lab0.pack()

        self.lab1 = Label(self.fenster, text = 'Ergebnis: Richtung und Entfernung', font=('Arial',9), fg='black')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.c.pack()

        self.frame4 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame4.pack()
        self.objektpunkt1= Label(self.frame4, text = 'Objektpunkt   y\u1D62  ',  font=('Arial',10))
        self.objektpunkt1.grid(column=0, columnspan=2, row=0)
        self.objektpunkt1.pack
        self.objektpunkt2= Label(self.frame4, text = 'x\u1D62',  font=('Arial',10))
        self.objektpunkt2.grid(column=2, row=0)
        self.objektpunkt2.pack
        self.objektpunkt3= Label(self.frame4, text = '', font=('Arial',10))
        self.objektpunkt3.grid(column=3, row=0)
        self.objektpunkt3.pack
        self.tyi = Label(self.frame4, text = 'UTM', font=('Arial',10))
        self.tyi.grid(column=0, row=1)
        self.tyi.pack
        self.yi = Entry(self.frame4, width=9)
        self.yi.insert(0, "")
        self.yi.grid(column=1, row=1)
        self.yi.pack
        self.xi = Entry(self.frame4, width=9)
        self.xi.insert(0, "")
        self.xi.grid(column=2, row=1)
        self.xi.pack
        self.txi = Label(self.frame4, width=0, text = '')
        self.txi.grid(column=3, row=1)
        self.txi.pack

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.c.pack(pady=6)

        self.frame5 = Frame(self.fenster, relief=FLAT, bd=0)
        self.frame5.pack()
        self.brechnen= Button(self.frame5, width=6, text ='Rechnen', bd=5,
          command = self.orth)
        self.brechnen.pack(side=LEFT)

        self.button= Button(self.frame5, width=6, text ='Objekt', bd=5,
          command = self.neupunkt)
        self.button.pack(side=LEFT)

        self.bneu = Button(self.frame5, width=4, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, width=4, text = "Ende", fg='red', bd=5,
          command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Orthogonale und polare Elemente")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v01.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv01.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik schließen", fg='white', bg='red', bd=2, relief=GROOVE,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v01.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.marke = 0
        self.fenster.destroy()
        self.__init__()
 
    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def taste(self, event):
        if self.marke == 0:
            self.warnzeichen()
        self.marke = 1
        self.brechnen["text"] = 'Erneut\nRechnen'

    def neupunkt(self):
        self.yi.delete(0,END)
        self.xi.delete(0,END)
        self.yi.focus()
        if self.marke == 1:
            self.fyilokal.delete(0,END)
            self.fxilokal.delete(0,END)
            self.fylot.delete(0,END)
            self.fxlot.delete(0,END)
            self.fwigon.delete(0,END)
            self.fsai.delete(0,END)
            self.fsailokal.delete(0,END)
            self.fsailokal2.delete(0,END)
        self.warnzeichen()
        self.marke = 0

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
#--------------------------------------------------------------------
    def orth(self):        
        if self.fenster.bind('<KeyPress>', self.taste):
            self.marke = 0
        try:
            fya = float(self.ya.get())
            fye = float(self.ye.get())
            fxa = float(self.xa.get())
            fxe = float(self.xe.get())
            if fye == fya and fxe == fxa:
                self.lab1["text"] = "Fehler, Anfangs- gleich Endpunkt"
                self.lab1["fg"] = "red"
                self.warnzeichen()
                self.neupunkt
                return
            freduktionsfaktor = float(self.reduktionsfaktor.get())
            ftaegon, fsae = self.riwis(fye - fya, fxe - fxa)
            self.lab0["text"] = 'Def.: Strecke (hor.) \u00D7 r  =  Strecke (UTM)'
            self.lab0["text"] += "\nx\u2091 (lokal) = " + str(round(fsae/freduktionsfaktor,3))
            self.lab1["text"] = "Richtungswinkel t\u2090,\u2091 = "  + str(round(ftaegon,4)) +\
                " gon\nEntfernung s\u2090,\u2091 = " + str(round(fsae,3))
            self.lab1["font"] = 'Arial',10
            self.lab1["fg"] = 'green'

            if self.yi.get():
                fyi = float(self.yi.get())
                fxi = float(self.xi.get())
                ftaigon, fsai = self.riwis(fyi - fya, fxi - fxa)
                fwigon = ftaigon - ftaegon
                if fwigon < 0.: fwigon += 400.
                fyilokal = math.sin(fwigon * math.pi/200.) * fsai
                fxilokal = math.cos(fwigon * math.pi/200.) * fsai
                fylot = fya + (fye-fya)* fxilokal/fsae
                fxlot = fxa + (fxe-fxa)* fxilokal/fsae
                fyilokal /= freduktionsfaktor; fxilokal /= freduktionsfaktor
                fsailokal = fsai/freduktionsfaktor

                self.objektpunkt3["text"] = "s\u2090,\u1D62"
                self.lab7a = Label(self.frame4, text = "lokal", font=('Arial',10))
                self.lab7a.grid(column=0, row=2)
                self.lab7a.pack
                self.fyilokal = Entry(self.frame4, width = 9, bg='yellow')
                self.fyilokal.grid(column=1, row=2)
                self.fyilokal.pack
                self.fyilokal.delete(0,END)
                self.fyilokal.insert(0, str(round(fyilokal,3)))
                self.fxilokal = Entry(self.frame4, width=9, bg='Lightyellow')
                self.fxilokal.grid(column=2, row=2)
                self.fxilokal.pack
                self.fxilokal.delete(0,END)
                self.fxilokal.insert(0, str(round(fxilokal,3)))
                self.fsailokal = Entry(self.frame4, width=8, bg='Lightyellow')
                self.fsailokal.insert(0, str(round(fsailokal,3)))
                self.fsailokal.grid(column=3, row=2)
                self.fsailokal.pack

                self.lab7c = Label(self.frame4, text = "Lot(UTM)", font=('Arial',10))
                self.lab7c.pack
                self.lab7c.grid(column=0, row=3)
                self.fylot = Entry(self.frame4, width=9, bg='Lightyellow')
                self.fylot.grid(column=1, row=3)
                self.fylot.pack
                self.fylot.delete(0,END)
                self.fylot.insert(0, str(round(fylot,3)))
                self.fxlot = Entry(self.frame4, width=9, bg='Lightyellow')
                self.fxlot.grid(column=2, row=3)
                self.fxlot.pack
                self.fxlot.delete(0,END)
                self.fxlot.insert(0, str(round(fxlot,3)))
                self.fsai = Entry(self.frame4, width=8, bg='Lightyellow')
                self.fsai.grid(column=3, row=3)
                self.fsai.pack
                self.fsai.insert(0,str(round(fsai,3)))

                self.lab7e = Label(self.frame4, text = "\u03B1 [gon]", font=('Arial',9))
                self.lab7e.grid(column=0, row=4)
                self.lab7e.pack
                self.fwigon = Entry(self.frame4, width=9, bg='yellow')
                self.fwigon.grid(column=1, row=4)
                self.fwigon.pack
                self.fwigon.delete(0,END)
                self.fwigon.insert(0, str(round(fwigon,4)))
                self.lab7f = Label(self.frame4, text ="lokal", font=('Arial',10))
                self.lab7f.grid(column=2, row=4)
                self.lab7f.pack
                self.fsailokal2 = Entry(self.frame4, width=8, bg='yellow')
                self.fsailokal2.grid(column=3, row=4)
                self.fsailokal2.pack
                self.fsailokal2.delete(0,END)
                self.fsailokal2.insert(0, str(round(fsailokal,3)))
            self.tueber["text"] = "\u2713"
            self.tueber["fg"] = 'limegreen'
            self.brechnen["text"] = "Rechnen"

        except:
            self.lab1["text"] = "Fehler, falsches Zeichen,\nunerlaubt leeres Feld … ?"
            self.lab1["fg"] = "red"
            self.warnzeichen()

# Ende class Ortho():

#****************************************************************

class PolaraufnahmeGerade():  #02
 
    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack(pady = 10)
        self.tueber = Label(self.frame, text = "", font=('Arial',11))
        self.tueber.pack( side = RIGHT)
        self.ueber = Label(self.frame, text = "Polaraufnahme\n (lokale Geradlinigkeit) ",
                           fg='blue', font=('Arial',11))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.tra = Label(self.frame2, text = '     Richtung  Zenitd.  Schrägstrecke', font=('Arial',9))
        self.tra.pack
        self.tra.grid(column=0, columnspan=4, row=0,  pady=3)
        self.ta = Label(self.frame2, text =' A', font=('Arial',10))
        self.ta.pack
        self.ta.grid(column=0, row=1)
        self.ra = Entry(self.frame2, width=8)
        self.ra.grid(column=1, row=1)
        self.ra.pack
        self.ra.focus()
        self.za = Entry(self.frame2, width=8)
        self.za.grid(column=2, row=1)
        self.za.pack
        self.za.insert(0, "100.0")
        self.sa = Entry(self.frame2, width=8)
        self.sa.grid(column=3, row=1, pady=4)
        self.sa.pack

        self.te= Label(self.frame2, text =' E', font=('Arial',10))
        self.te.pack
        self.te.grid(column=0, row=2)
        self.re = Entry(self.frame2, width=8)
        self.re.grid(column=1, row=2)
        self.re.pack
        self.ze = Entry(self.frame2, width=8)
        self.ze.grid(column=2, row=2)
        self.ze.pack
        self.ze.insert(0, "100.0")
        self.se = Entry(self.frame2, width=8)
        self.se.grid(column=3, row=2, pady=4)
        self.se.pack
        self.lab1 = Label(self.fenster, text = '', fg = "black")
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.1c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.c.pack()

        self.frame3 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame3.pack()
        self.ti= Label(self.frame3, text =' Objektpunkt i ', font=('Arial',10))
        self.ti.pack
        self.ti.grid(column=0, columnspan=4, row=0)
        self.tra= Label(self.frame3, text = ' Richtung  Zenitd.  Schrägstrecke ', font=('Arial',9))
        self.tra.grid(column=1, columnspan=3, row=1)
        self.tra.pack
        self.ri = Entry(self.frame3, width=8)
        self.ri.grid(column=1, row=2)
        self.ri.pack
        self.zi = Entry(self.frame3, width=8)
        self.zi.grid(column=2, row=2)
        self.zi.pack
        self.zi.insert(0, "100.0")
        self.si = Entry(self.frame3, width=8)
        self.si.grid(column=3, row=2, pady=4)
        self.si.pack

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.c.pack(pady=6)

        self.frame5 = Frame(self.fenster, relief=FLAT)
        self.frame5.pack()
        self.brechnen= Button(self.frame5, text ='Rechnen', width=6, height=2, bd=5, command = self.polar)
        self.brechnen.pack(side=LEFT)
        self.bnaechsterpunkt = Button(self.frame5, text ='Nächster\nPunkt',width=6, height=2, bd=5, command = self.neupunkt)
        self.bnaechsterpunkt.pack(side=LEFT)
        self.bneu = Button(self.frame5, text = "Neu", width=4, height=2, bd=5, command = self.neu)
        self.bneu.pack(side=LEFT)
        self.bende = Button(self.frame5, text = "Ende", width=4, height=2, fg='red',bd=5, command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Polaraufnahme (lokale Geradlinigkeit)")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v02.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv02.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v02.png>\n ist nicht vorhanden.")

    def neu(self):
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'
        try:
            self.Byi.delete(0,END)
        except: pass

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def neupunkt(self):
        try:
            if self.marke == 1:
                self.ri.delete(0,END)
                self.si.delete(0,END)
                self.zi.delete(0,END)
                self.zi.insert(0, "100.0")
                self.ri.focus()
                self.lab2["text"] = ""
                self.lab3["text"] = ""
                self.Byi.delete(0,END)
            self.lab1["text"] = ""
            self.lab1["fg"] = "black"
            self.warnzeichen()
            self.marke = 0
        except:
            self.fenster.destroy()
            self.__init__()

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def polar(self):
        self.tueber["text"] = " \u2713"
        self.tueber["fg"] = 'limegreen'
        self.brechnen["text"] = 'Rechnen'
        if self.fenster.bind('<KeyPress>', self.taste):
            self.marke = 1
        try:
            if self.ra.get() == self.re.get():
                self.lab1["text"] = "Anfangs- und Endrichtung leer oder gleich"
                self.lab1["fg"] = "red"
                self.warnzeichen()
                return
            fra = float(self.ra.get())
            fza = float(self.za.get())
            fsa = float(self.sa.get()) * math.sin(fza * math.pi / 200.)
            fre = float(self.re.get())
            fze = float(self.ze.get())
            fse = float(self.se.get()) * math.sin(fze * math.pi / 200.)
            fri = float(self.ri.get())
            fzi = float(self.zi.get())
            fsi = float(self.si.get()) * math.sin(fzi * math.pi / 200.)
            alpha = fre - fra
            alphai = fri - fra
            fxa = fsa
            fya = 0.
            fxe = fse * math.cos(alpha* math.pi / 200.)
            fye = fse * math.sin(alpha* math.pi / 200.)
            fxi = fsi * math.cos(alphai* math.pi / 200.)
            fyi = fsi * math.sin(alphai* math.pi / 200.)

            fsae = math.hypot(fye-fya, fxe-fxa)
            fsai = math.hypot(fyi-fya, fxi-fxa)

            o = fye/fsae; a = (fxe-fxa)/fsae
            Byi = a*fyi + o*(fxa-fxi)
            Bxi = o*fyi + a*(fxi-fxa)
            Bys = o*fxa
            Bxs = -a*fxa

            self.lab1["text"] = "Entfernung   s\u2090,\u2091 =  x\u2091 = " + str(round(fsae,3)) +\
                "\nStandpunkt    y\u209B = " + str(round(Bys,3)) + ",  x\u209B = " + str(round(Bxs,3))
            self.lab1["fg"] = "black"

            self.lab2 = Label(self.frame3, text = "y\u1D62 =", font=('Arial',9))
            self.lab2.grid(column=0, row=3)
            self.Byi = Entry(self.frame3, width = 8, bg='yellow')
            self.Byi.grid(column=1, row=3)
            self.Byi.pack
            self.Byi.delete(0,END)
            self.Byi.insert(0, str(round(Byi,3)))
            self.lab3 = Label(self.frame3, text = "x\u1D62 = "\
                + str(round(Bxi,3)) + "   a\u1D62 = " + str(round(fsai,3)), font=('Arial',9))
            self.lab3.grid(column=2, columnspan=2, row=3)

        except:
            self.lab1["text"] = "Fehler, falsches Zeichen,\nunerlaubt leeres Feld ...?"
            self.lab1["fg"] = "red"
            self.warnzeichen()

# Ende Polaraufnahme (Geradlinigkeit)

#**************************************************************** 

class Polaraufnahme():   #03

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400. : t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------
    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack(pady = 10)
        self.tueber = Label(self.frame, text = "", font=('Arial',11))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = " Polaraufnahme \n(Koordinaten)",
                           fg='blue', font=('Arial',11))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.anfangspunkt = Label(self.frame2, text = 'Standpunkt',
                   width=14, font=('Arial',10))
        self.anfangspunkt.grid(columnspan=4, row=0)
        self.anfangspunkt.pack
        self.tys = Label(self.frame2, text = ' y\u209B ', font=('Arial',11))
        self.tys.grid(column=0, row=1)
        self.tys.pack
        self.ys = Entry(self.frame2, width=9)
        self.ys.grid(column=1, row=1)
        self.ys.pack
        self.ys.focus()
        self.txs = Label(self.frame2, text = '  x\u209B ',font=('Arial',11))
        self.txs.grid(column=2, row=1)
        self.txs.pack
        self.xs = Entry(self.frame2, width=9)
        self.xs.grid(column=3, row=1, pady=2)
        self.xs.pack

        self.endpunkt = Label(self.frame2, text = 'Anschlusspunkt', width = 16, font=('Arial',10))
        self.endpunkt.grid(columnspan=4, row=3)
        self.endpunkt.pack
        self.tya= Label(self.frame2, text = ' y\u2090 ', font=('Arial',11))
        self.tya.grid(column=0, row=4)
        self.tya.pack
        self.ya = Entry(self.frame2, width=9)
        self.ya.grid(column=1, row=4)
        self.ya.pack
        self.txa = Label(self.frame2, text = '  x\u2090 ', font=('Arial',11))
        self.txa.grid(column=2, row=4)
        self.txa.pack
        self.xa = Entry(self.frame2, width=9)
        self.xa.grid(column=3, row=4)
        self.xa.pack
        self.tra = Label(self.frame2, text = 'Anschluss [gon]', font=('Arial',9))
        self.tra.grid(column=0, columnspan=3, row=5)
        self.tra.pack
        self.ra = Entry(self.frame2, width=9)
        self.ra.grid(column=3, row=5)
        self.ra.insert(0, "0")
        self.ra.pack
        self.ttm = Label(self.frame2, text = 'Maßstabsfaktor m', font=('Arial',9))
        self.ttm.grid(column=0, columnspan=3, row=6)
        self.ttm.pack
        self.massstabsfaktor = Entry(self.frame2, width=9)
        self.massstabsfaktor.grid(column=3, row=6, pady=2)
        self.massstabsfaktor.insert(0, "1")
        self.massstabsfaktor.pack

        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.c.pack()

        self.frame4 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame4.pack()
        self.endpunkt = Label(self.frame4, text = ' Objektpunkt \u1D62 (polar) ', width = 20, font=('Arial',10))
        self.endpunkt.grid(column=0, columnspan=4, row=0)
        self.endpunkt.pack

        self.tri= Label(self.frame4, text = '       Richtung \u1D62 [gon] ',font=('Arial',9))
        self.tri.grid(column=0, columnspan=3, row=1)
        self.tri.pack
        self.ri = Entry(self.frame4, width=8)
        self.ri.grid(column=3, columnspan=1, row=1)
        self.ri.pack
        self.tzi= Label(self.frame4, text = 'Zenitdistanz \u1D62 [gon]',font=('Arial',9))
        self.tzi.grid(column=0, columnspan=3, row=2)
        self.tzi.pack
        self.zi = Entry(self.frame4, width=8)
        self.zi.grid(column=3, columnspan=1, row=2)
        self.zi.pack
        self.zi.insert(0, "100.0")
        self.tsi = Label(self.frame4, text = '   Schrägstrecke s \u1D62 ', font=('Arial',9))
        self.tsi.grid(column=0, columnspan=3, row=3)
        self.tsi.pack
        self.si= Entry(self.frame4, width=8)
        self.si.grid(column=3, columnspan=1, row=3)
        self.si.pack
        self.tyi= Label(self.frame4, text = 'y\u1D62',font=('Arial',11))
        self.tyi.grid(column=0, row=4)
        self.tyi.pack
        self.yi= Entry(self.frame4, width=9, bg='Lightyellow')
        self.yi.grid(column=1, row= 4)
        self.yi.pack
        self.txi = Label(self.frame4, text = ' x\u1D62 ', font=('Arial',11))
        self.txi.grid(column=2, row=4)
        self.txi.pack
        self.xi = Entry(self.frame4, width=9, bg='Lightyellow')
        self.xi.grid(column=3, row=4)
        self.xi.pack

        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=FLAT,bd=0)
        self.frame5.pack()
        self.brechnen= Button(self.frame5, text ='Rechnen', width=6, height=2, bd=5,
          command = self.polar)
        self.brechnen.pack(side=LEFT)
        self.bnaechster = Button(self.frame5, text ='Nächster\nPunkt', width=6, height=2, bd=5, command = self.neupunkt)
        self.bnaechster.pack(side=LEFT)
        self.bneu = Button(self.frame5, text = "Neu", width=4, height=2, bd=5, command = self.neu)
        self.bneu.pack(side=LEFT)
        self.bende = Button(self.frame5, text = "Ende", width=4, height=2, fg='red',bd=5, command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Polaraufnahme (Koordinaten)")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v03.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv03.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v03.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'
        self.yi.delete(0,END)
        self.xi.delete(0,END)

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def neupunkt(self):
        self.ri.delete(0,END)
        self.si.delete(0,END)
        self.ri.focus()
        self.yi.delete(0,END)
        self.xi.delete(0,END)
        self.zi.delete(0,END)
        self.zi.insert(0, "100.0")
        self.warnzeichen()
        self.marke = 1
        self.lab2["text"] = "Neue Eingabe"

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def polar(self):
        if self.fenster.bind('<KeyPress>', self.taste):
            self.marke = 1
        try:
            fys = float(self.ys.get())
            fya = float(self.ya.get())
            fxs = float(self.xs.get())
            fxa = float(self.xa.get())
            if fys == fya and fxs == fxa :
                self.lab1["text"] = "Fehler, Standpunkt gleich Anschluss"
                self.lab1["fg"] = "red"
                self.warnzeichen()
                return
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            self.lab2["text"] = ""
            ftsa, fsa = self.riwis(fya - fys, fxa - fxs)
            self.lab1["text"] = "Richtungswinkel t\u209B,\u2090 = "  + str(round(ftsa,4)) +\
                " gon\nEntfernung s\u209B,\u2090 = " + str(round(fsa,3))
            self.lab1["fg"] = "black"
            if self.ra.get() or self.ri.get():
                fra = float(self.ra.get())
                fri = float(self.ri.get())
                ftsi = fri - fra + ftsa
                fmassstab = float(self.massstabsfaktor.get())
                fsi = float(self.si.get())
                fzi = float(self.zi.get())
                fsih = fsi *  math.sin(math.pi*fzi/200.)
                fyi = fys + math.sin(ftsi /63.6619773675812) * fsih * fmassstab
                fxi = fxs + math.cos(ftsi /63.6619773675812) * fsih * fmassstab

                self.yi.delete(0,END)
                self.yi.insert(0, str(round(fyi,3)))
                self.xi.delete(0,END)
                self.xi.insert(0, str(round(fxi,3)))

                fsai = math.hypot(fyi-fya, fxi-fxa)
            self.brechnen["text"] = 'Rechnen'
            if self.ra.get() or self.ri.get():
                self.lab2["text"] = "Horizontalstrecke  s \u1D62 = " + str(round(fsih,3))+\
                   "\nStrecke  s \u2090,\u1D62 = " + str(round(fsai,3))             
                self.lab2["fg"] = "black"
        except:
            self.lab2["text"] = "Fehler, falsches Zeichen,\nunerlaubt leeres Feld … ?"
            self.lab2["fg"] = "red"
            self.warnzeichen()

#Ende class Polaraufnahme()

#**************************************************************** 

class Transformation(): #04

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',12))
        self.tueber.pack( side = RIGHT)
        self.ueber = Label(self.frame, text = " Transformation \nKleinpunkte", fg='blue', font=('Arial',11))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild) 
        self.binfo.pack(side=RIGHT)
        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.systemA = Label(self.frame2, text = 'von System A', width=14, font=('Arial',10))
        self.systemA.grid(column=1, row=0, columnspan=2)
        self.systemA.pack
        self.tAa= Label(self.frame2, text = ' A (y\u2090, x\u2090) ', font=('Arial',9))
        self.tAa.grid(column=0, row=1)
        self.tAa.pack
        self.yaA = Entry(self.frame2, width=9)
        self.yaA.insert(0, "0")
        self.yaA.grid(column=1, row=1)
        self.yaA.pack
        self.xaA = Entry(self.frame2, width=9)
        self.xaA.insert(0, "0")
        self.xaA.grid(column=2, row=1)
        self.xaA.pack

        self.tAe= Label(self.frame2, text = ' A (y\u2091, x\u2091) ', font=('Arial',9))
        self.tAe.grid(column=0, row=2)
        self.tAe.pack
        self.yeA = Entry(self.frame2, width=9)
        self.yeA.grid(column=1, row=2)
        self.yeA.insert(0, "0")
        self.yeA.pack
        self.xeA = Entry(self.frame2, width=9)
        self.xeA.grid(column=2, row=2, pady=4)
        self.xeA.insert(0, "0")
        self.xeA.pack

        self.systemB = Label(self.frame2, text = 'nach System B', width=14, font=('Arial',10))
        self.systemB.grid(column=1, row=4, columnspan=2, padx=0,pady=0)
        self.systemB.pack
        self.tBa= Label(self.frame2, text = ' B (y\u2090, x\u2090) ', font=('Arial',9))
        self.tBa.grid(column=0, row=5)
        self.tBa.pack
        self.yaB = Entry(self.frame2, width=9)
        self.yaB.grid(column=1, row=5)
        self.yaB.pack
        self.xaB = Entry(self.frame2, width=9)
        self.xaB.grid(column=2, row=5)
        self.xaB.pack
        self.tBe= Label(self.frame2, text = ' B (y\u2091, x\u2091) ', font=('Arial',9))
        self.tBe.grid(column=0, row=6)
        self.tBe.pack
        self.yeB = Entry(self.frame2, width=9)
        self.yeB.grid(column=1, row=6)
        self.yeB.pack
        self.xeB = Entry(self.frame2, width = 9)
        self.xeB.grid(column=2, row=6, pady=4)
        self.xeB.pack

        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT) 
        self.re = self.c.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.c.pack()

        self.frame3 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame3.pack()
        self.eingabeSystemA = Label(self.frame3, text = 'Eingabe System A', width =15, font=('Arial',10))
        self.eingabeSystemA.grid(column=0, columnspan=4, row=0)
        self.eingabeSystemA.pack
        self.tyiA= Label(self.frame3, text = ' A (y\u1D62) ', font=('Arial',9))
        self.tyiA.grid(column=0, row=1)
        self.tyiA.pack 
        self.yiA = Entry(self.frame3, width=9)
        self.yiA.insert(0, "0")
        self.yiA.grid(column=1, row=1)
        self.yiA.pack 
        self.txiA = Label(self.frame3, text = ' A (x\u1D62) ', font=('Arial',9))
        self.txiA.grid(column=2, row=1)
        self.txiA.pack
        self.xiA = Entry(self.frame3, width=9)
        self.xiA.grid(column=3, row=1, pady=2)
        self.xiA.pack

        self.ausgabeSystemB = Label(self.frame3, text = 'Ausgabe System B', width =15, font=('Arial',10))
        self.ausgabeSystemB.grid(column=0, columnspan=4, row=2 )
        self.ausgabeSystemB.pack
        self.tyiB= Label(self.frame3, text = ' B (y\u1D62) ', font=('Arial',9))
        self.tyiB.grid(column=0, row=3 )
        self.tyiB.pack
        self.yiB = Entry(self.frame3, width =9,  bg='Lightyellow' )
        self.yiB.grid(column=1, row=3 )
        self.yiB.pack
        self.txiB = Label(self.frame3, text = ' B (x\u1D62) ', font=('Arial',9))
        self.txiB.grid(column=2, row=3 )
        self.txiB.pack
        self.xiB = Entry(self.frame3, width = 9, bg='Lightyellow')
        self.xiB.grid(column=3, row=3, pady=2)
        self.xiB.pack
        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT) 
        self.re = self.c.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=FLAT,bd=0)
        self.frame5.pack()
        self.brechnen= Button(self.frame5, width=6, height=2, text ='Rechnen', bd=5,
                command = self.trans)
        self.brechnen.pack(side=LEFT)
        self.brechnen2= Button(self.frame5, width=7, height=2, text ='Nächster\nPunkt', bd=5,
            command = self.neupunkt)
        self.brechnen2.pack(side=LEFT)
        self.bneu = Button(self.frame5, width=4, height=2, text = "Neu", bd=5,
             command = self.neu)
        self.bneu.pack(side=LEFT)
        self.bende = Button(self.frame5, width=4, height=2,text = "Ende", fg='red', bd=5,
             command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Transformation, Kleinpunkte")).pack()
            try:
               current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
               current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v04.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv04.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.newWindow.mainloop()
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v04.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        if self.yiB: self.yiB.delete(0,END)
        if self.xiB: self.xiB.delete(0,END)
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def taste(self, event):
        self.warnzeichen()
        self.xeA["bg"] = "white"
        self.brechnen["text"] = 'Erneut\nRechnen'
        self.lab2["text"] = ""

    def neupunkt(self):
        if self.yiA:
            self.yiA.delete(0,END)
            self.yiA.insert(0, "0")
        self.xiA.delete(0,END)
        self.warnzeichen()
        self.xeA["bg"] = "white"
        self.lab2["text"] = "Neue Eingabe"

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def trans(self):
        if self.marke == 1:
            self.yiB.delete(0,END)
            self.xiB.delete(0,END)
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        try:
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            Aya = float(self.yaA.get())
            Aye = float(self.yeA.get())
            Axa = float(self.xaA.get())
            Axe = float(self.xeA.get())
            Bya = float(self.yaB.get())
            Bye = float(self.yeB.get())
            Bxa = float(self.xaB.get())
            Bxe = float(self.xeB.get())
            Ayi = float(self.yiA.get())
            Axi = float(self.xiA.get())

            Bs = math.hypot(Bye - Bya, Bxe - Bxa)
            if abs(Axe) < 0.0000000002:
                self.marke = 2
                Axe = math.sqrt(Bs*Bs - (Aye-Aya)*(Aye-Aya)) + Axa
                As = math.hypot(Axe - Axa, Aye - Aya)
                self.xeA.delete(0,END)
                self.xeA.insert(0, str(round(Axe,3)))
                self.xeA["bg"] = "Lightgreen"
            else:
                As = math.hypot(Aye-Aya, Axe-Axa)
                self.marke = 0
            if As == 0 or Bs == 0:
                self.lab2["text"] = "Transformation nicht möglich\nAchslängen = 0 "
                self.lab2["fg"] = "red"
                self.marke = 0
                self.warnzeichen()
                return
            fs = Bs-As
            fmassstab =Bs/As
            p = ((Axe - Axa) * (Bye - Bya) - (Aye - Aya) * (Bxe - Bxa))/As/As
            q = ((Aye - Aya) * (Bye - Bya) + (Axe - Axa) * (Bxe - Bxa))/As/As
            label =  "Transformationsachse A\u2090,\u2091 = "  + str(round(As,3)) +\
                            "\nTransformationsachse B\u2090,\u2091 = " + str(round(Bs,3)) +\
                            "\n Abweichung f\u209B = " + str(round(fs,3))+\
                            "\nA\u00D7m =B; Maßstabsfaktor m=" + str(round(fmassstab,7))
            if self.marke == 0:
                self.lab1["text"] = label
            elif self.marke == 2:
                self.lab1["text"] = label + "\nDa der der Fußpunkt A(x\u2091) mit der \nEingabe = 0 unbekannt ist, wird\
\ndie Achslänge des Systems B\n auch für das System A genommen."
                self.marke = 1
            Byi = Bya + p * (Axi - Axa) + q * (Ayi - Aya)
            Bxi = Bxa + q * (Axi - Axa) - p * (Ayi - Aya)
            self.marke = 1
            self.yiB.insert(0, str(round(Byi,3)))
            self.xiB.insert(0, str(round(Bxi,3)))

            self.lab2["text"] = ""
            self.lab2["fg"] = "black"
            self.brechnen["text"] = 'Rechnen'
        except:
            self.lab2["text"] = "Fehler, falsches Zeichen,\nunerlaubt leeres Feld … ?"
            self.lab2["fg"] = "red"
            self.warnzeichen()

# Ende class Transformation():

#**************************************************************** 

class Geradenschnitte():  #05

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200. 
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400.: t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------
    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "",
                          font=('Arial',12))
        self.tueber.pack( side = RIGHT, pady=10)
        self.ueber = Label(self.frame, text = " Geradenschnitte ",
                           fg='blue', font=('Arial',11))
        self.ueber.pack(fill="both", side= RIGHT, pady=10)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack()
        self.anfangspunkt= Label(self.frame2, text = 'Ausgangsgerade',
                                 width = 25, font=('Arial',10))
        self.anfangspunkt.grid(column=0,columnspan=4, row=0)
        self.anfangspunkt.pack
        self.ty1= Label(self.frame2, text = ' y\u2081', font=('Arial',11))
        self.ty1.grid(column=0, row=1)
        self.ty1.pack
        self.y1 = Entry(self.frame2, width=9)
        self.y1.grid(column=1, row=1)
        self.y1.pack
        self.y1.focus()
        self.tx1 = Label(self.frame2, text = ' x\u2081', font=('Arial',11))
        self.tx1.grid(column=2, row=1)
        self.tx1.pack
        self.x1 = Entry(self.frame2, width=9)
        self.x1.grid(column=3, row=1)
        self.x1.pack
        self.ty2= Label(self.frame2, text = ' y\u2082', font=('Arial',11))
        self.ty2.grid(column=0, row=3)
        self.ty2.pack
        self.y2 = Entry(self.frame2, width=9)
        self.y2.grid(column=1, row=3)
        self.y2.pack
        self.tx2 = Label(self.frame2, text = ' x\u2082', font=('Arial',11))
        self.tx2.grid(column=2, row=3)
        self.tx2.pack
        self.x2 = Entry(self.frame2, width=9)
        self.x2.grid(column=3, row=3, pady=2)
        self.x2.pack

        self.ta1 = Label(self.frame2, text = 'paralleler Abstand', font=('Arial',9))
        self.ta1.grid(column=0, columnspan=3, row=4)
        self.ta1.pack
        self.a1 = Entry(self.frame2, width=9)
        self.a1.grid(column=3, row=4)
        self.a1.insert(0, "0")
        self.a1.pack
        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', fill = 'green')
        self.c.pack()

        self.frame3 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame3.pack()
        self.anfangspunkt= Label(self.frame3, text = 'Gerade i',
                                 width = 25, font=('Arial',10))
        self.anfangspunkt.pack
        self.anfangspunkt.grid(columnspan=4, row=0,  pady=2)
        self.ty3= Label(self.frame3, text = ' y\u2083', font=('Arial',11))
        self.ty3.grid(column=0, row=1)
        self.ty3.pack
        self.y3 = Entry(self.frame3, width=9)
        self.y3.grid(column=1, row=1)
        self.y3.pack
        self.tx3 = Label(self.frame3, text = ' x\u2083', font=('Arial',11))
        self.tx3.grid(column=2, row=1)
        self.tx3.pack
        self.x3 = Entry(self.frame3, width=9)
        self.x3.grid(column=3, row=1)
        self.x3.pack
        self.ty4= Label(self.frame3, text = ' y\u2084', font=('Arial',11))
        self.ty4.grid(column=0, row=3)
        self.ty4.pack
        self.y4 = Entry(self.frame3, width=9)
        self.y4.grid(column=1, row=3)
        self.y4.pack
        self.tx4 = Label(self.frame3, text = ' x\u2084', font=('Arial',11))
        self.tx4.grid(column=2, row=3)
        self.tx4.pack
        self.x4 = Entry(self.frame3, width=9)
        self.x4.grid(column=3, row=3)
        self.x4.pack

        self.ta2 = Label(self.frame3, text = 'paralleler Abstand', font=('Arial',9))
        self.ta2.grid(column=0, columnspan=3, row=4)
        self.ta2.pack
        self.a2 = Entry(self.frame3, width=9)
        self.a2.insert(0, "0")
        self.a2.grid(column=3, row=4, pady=2)
        self.a2.pack

        self.tyi = Label(self.frame3, text = ' y\u1D62',font=('Arial',11))
        self.tyi.grid(column=0, row=5)
        self.tyi.pack
        self.yi = Entry(self.frame3, width=9, bg='Lightyellow')
        self.yi.grid(column=1, row= 5)
        self.yi.pack
        self.txi = Label(self.frame3, text = ' x\u1D62 ', font=('Arial',11))
        self.txi.grid(column=2, row=5)
        self.txi.pack
        self.xi = Entry(self.frame3, width=9, bg='Lightyellow')
        self.xi.grid(column=3, row=5, pady=1)
        self.xi.pack

        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.re = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=RIDGE,bd=0)
        self.frame5.pack()
        self.brechnen = Button(self.frame5,height=2,width=6, text ='Rechnen', bd=5,
            command = self.geradenschnitt)
        self.brechnen.pack(side=LEFT)

        self.bneu2= Button(self.frame5, height=2, width=7, text ='Nächster\nSchnitt', bd=5,
            command = self.neu2)
        self.bneu2.pack(side=LEFT)

        self.bneu = Button(self.frame5, height=2, width=4, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, height=2, width=4, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Geradenschnitte")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v05.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv05.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v05.png>\n ist nicht vorhanden.") 

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'
        self.yi.delete(0,END)
        self.xi.delete(0,END)

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def neu2(self):
        self.y3.delete(0,END)
        self.x3.delete(0,END)
        self.y4.delete(0,END)
        self.x4.delete(0,END)
        self.a2.delete(0,END)
        self.a2.insert(0, "0")
        self.yi.delete(0,END)
        self.xi.delete(0,END)
        self.y3.focus()
        self.anfangspunkt["text"] = "Gerade i (neue Eingabe)"
        self.lab2["text"] = ""
        self.warnzeichen()
        self.marke = 0

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def geradenschnitt(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        self.tueber["text"] = " \u2713"
        self.tueber["fg"] = 'limegreen'
        try:
            fy1 = float(self.y1.get())
            fx1 = float(self.x1.get())
            fy2 = float(self.y2.get())
            fx2 = float(self.x2.get())
            fy3 = float(self.y3.get())
            fx3 = float(self.x3.get())
            fy4 = float(self.y4.get())
            fx4 = float(self.x4.get())
            fa1 = float(self.a1.get())
            fa2 = float(self.a2.get())

            ft12, fs12 = self.riwis(fy2 - fy1, fx2 - fx1)
            ft34, fs34 = self.riwis(fy4 - fy3, fx4 - fx3)

            falphagon = ft34 - ft12
            if falphagon < 0.: falphagon += 400.

            fyy1 = fy1 + fa1*(fx2 - fx1)/fs12; fyy2 = fy2 + fa1*(fx2 - fx1)/fs12
            fxx1 = fx1 - fa1*(fy2 - fy1)/fs12; fxx2 = fx2 - fa1*(fy2 - fy1)/fs12
            fyy3 = fy3 + fa2*(fx4 - fx3)/fs34; fyy4 = fy4 + fa2*(fx4 - fx3)/fs34
            fxx3 = fx3 - fa2*(fy4 - fy3)/fs34; fxx4 = fx4 - fa2*(fy4 - fy3)/fs34
            try:
                if abs(fxx1-fxx2) < 0.000002 and abs(fyy3-fyy4) < 0.000002:
                   fxi = fxx1
                   fyi = fyy3
                elif abs(fxx3-fxx4) < 0.000002 and abs(fyy1-fyy2) < 0.000002:
                   fxi = fxx3
                   fyi = fyy1

                elif abs(fxx1-fxx2) < 0.000002:
                   fxi = fxx1
                   fyi = fyy3 + (fxx1-fxx3)*(fxx4-fxx3)/(fyy4-fyy3)

                elif abs(fyy1-fyy2) < 0.000002:
                   fyi = fyy1
                   fxi = fxx3 + (fyy1-fyy3)*(fxx4-fxx3)/(fyy4-fyy3)

                elif abs(fxx3-fxx4) < 0.000002:
                   fxi = fxx3
                   fyi = fyy1 + (fxx3-fxx1)*(fxx2-fxx1)/(fyy2-fyy1)

                elif abs(fyy3-fyy4) < 0.000002:
                   fyi = fyy3
                   fxi = fxx1 + (fyy3-fyy1)*(fxx2-fxx1)/(fyy2-fyy1)
                else:
                    ss = (fy2-fy1) / (fx2-fx1)
                    tt = (fy4-fy3) / (fx4-fx3)
                    fxi = fxx3 + (fyy3-fyy1 + (fxx1-fxx3) * ss) / (ss - tt)
                    fyi = fyy3 + (fxi -fxx3) * tt

            except:
                t34, s34 = self.riwis(fyy4-fyy3, fxx4-fxx3)
                t12, s12 = self.riwis(fyy2-fyy1, fxx2-fxx1)
                t31, s31 = self.riwis(fyy1-fyy3, fxx1-fxx3)
                t13, s13 = self.riwis(fyy3-fyy1, fxx3-fxx1)
                falphagon = t34 - t12
                beta = t31 - t34
                alpha = t12 - t13
                b = math.sin(beta* math.pi/200.) * s31 / math.sin(falphagon * math.pi/200.)
                fyi = fyy1 + b * math.sin(beta * math.pi/200.)
                fxi = fxx1 + b * math.cos(beta * math.pi/200.)

            fs1=math.hypot(fy1-fyi, fx1-fxi)
            fs2=math.hypot(fy2-fyi, fx2-fxi)
            fs3=math.hypot(fy3-fyi, fx3-fxi)
            fs4=math.hypot(fy4-fyi, fx4-fxi)
            self.anfangspunkt["text"] = "Gerade i"

            self.yi.delete(0,END)
            self.yi.insert(0, str(round(fyi,3)))
            self.xi.delete(0,END)
            self.xi.insert(0, str(round(fxi,3)))

            self.lab1["text"] = "Richtung \u2081,\u2082 = " + str(round(ft12,4)) + \
                    ", Entfernung \u2081,\u2082 = " + str(round(fs12,3))

            ausgabe = "Richtung \u2083,\u2084 = " + str(round(ft34,4)) + \
                    ", Entfernung \u2083,\u2084 = " + str(round(fs34,3))+ "\nSchnittwinkel \u03B1 = " + str(round(falphagon,4)) +  " gon\n"
            if abs(fa1) < 0.000002 :
                ausgabe += "   s\u2081,\u1D62 = {0:>8.3f} \n".format(fs1)
                ausgabe += "   s\u2082,\u1D62 = {0:>8.3f} \n".format(fs2)
                if fs1 > fs12 or fs2 > fs12:
                    ausgabe += "Schnitt außerhalb des Geradenstücks \u2081,\u2082\n "
            if abs(fa2) < 0.000002 :
                ausgabe += "   s\u2083,\u1D62 = {0:>8.3f} \n".format(fs3)
                ausgabe += "   s\u2084,\u1D62 = {0:>8.3f}".format(fs4)
                if fs3 > fs34 or fs4 > fs34:
                    ausgabe += "\nSchnitt außerhalb des Geradenstücks \u2083,\u2084"
            self.lab2["text"] = ausgabe
            self.lab2["fg"] = "black"
            self.brechnen["text"] = 'Rechnen'
        except:
            self.lab2["text"] = "Falsches Zeichen, unerlaubt leeres Feld\nGeraden parallel … ?"
            self.lab2["fg"] = "red"
            self.warnzeichen()

# Ende class Geradenschnitte():

#****************************************************************

class KreisGerade():  #06

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400.: t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------
    def ortho(self, dye, dxe, dyi, dxi):
        re, se = self.riwis(dye, dxe)
        ri, si = self.riwis(dyi, dxi)
        wigon = ri - re
        hi = math.sin(wigon*math.pi/200.) * si
        ji = math.cos(wigon*math.pi/200.) * si
        return hi, ji, se

    def __init__(self):
        self.marke = 0
        self.tangente = False
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',12))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = " Kreis-Geraden-Schnitt ",
                           fg='blue', font=('Arial',11))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack()
        self.anfangspunkt= Label(self.frame2, text = 'Ausgangsbogen',
                                 width = 15, font=('Arial',10))
        self.anfangspunkt.grid(column=0, columnspan=4, row=0)
        self.anfangspunkt.pack
        self.ty1= Label(self.frame2, text = ' y\u2081', font=('Arial',11))
        self.ty1.grid(column=0, row=1)
        self.ty1.pack
        self.y1 = Entry(self.frame2, width=9)
        self.y1.grid(column=1, row=1)
        self.y1.pack
        self.y1.focus()
        self.tx1 = Label(self.frame2, text = ' x\u2081', font=('Arial',11))
        self.tx1.grid(column=2, row=1)
        self.tx1.pack
        self.x1 = Entry(self.frame2, width=9)
        self.x1.grid(column=3, row=1)
        self.x1.pack
        self.ty2= Label(self.frame2, text = ' y\u2082', font=('Arial',11))
        self.ty2.pack
        self.ty2.grid(column=0, row=3)
        self.y2 = Entry(self.frame2, width=9)
        self.y2.grid(column=1, row=3)
        self.y2.pack
        self.tx2 = Label(self.frame2, text = ' x\u2082', font=('Arial',11))
        self.tx2.grid(column=2, row=3)
        self.tx2.pack
        self.x2 = Entry(self.frame2, width=9)
        self.x2.grid(column=3, row=3, pady=2)
        self.x2.pack

        self.tradius = Label(self.frame2, text = '               Radius', width=15, font=('Arial',9))
        self.tradius .grid(column=0, columnspan=3, row=4, pady=4)
        self.tradius .pack
        self.radius = Entry(self.frame2, width=9)
        self.radius.grid(column=3, row=4, pady=2)
        self.radius.pack

        self.lab1 = Label(self.fenster)
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.c.pack()

        self.frame3 = Frame(self.fenster, relief=RIDGE,bd=4)
        self.frame3.pack()
        self.anfangspunkt = Label(self.frame3, text = 'Gerade i',
                                 width=20, font=('Arial',10))
        self.anfangspunkt.grid(columnspan=4, row=0, pady=2)
        self.anfangspunkt.pack
        self.ty3 = Label(self.frame3, text = ' y\u2083', font=('Arial',11))
        self.ty3.grid(column=0, row=1)
        self.ty3.pack
        self.y3 = Entry(self.frame3, width=9)
        self.y3.grid(column=1, row=1)
        self.y3.pack
        self.tx3 = Label(self.frame3, text = ' x\u2083', font=('Arial',11))
        self.tx3.grid(column=2, row=1)
        self.tx3.pack
        self.x3 = Entry(self.frame3, width=9)
        self.x3.grid(column=3, row=1)
        self.x3.pack

        self.ty4 = Label(self.frame3, text = ' y\u2084', font=('Arial',11))
        self.ty4.grid(column=0, row=3,  pady=2)
        self.ty4.pack
        self.y4 = Entry(self.frame3, width=9)
        self.y4.grid(column=1, row=3)
        self.y4.pack
        self.tx4 = Label(self.frame3,  text = ' x\u2084', font=('Arial',11))
        self.tx4.grid(column=2, row=3)
        self.tx4.pack
        self.x4 = Entry(self.frame3, width=9)
        self.x4.grid(column=3, row=3, pady=2)
        self.x4.pack
        self.tyi = Label(self.frame3, text = ' y\u1D62',font=('Arial',11))
        self.tyi.grid(column=0, row=5)
        self.tyi.pack
        self.yi = Entry(self.frame3, width=9, bg='Lightyellow')
        self.yi.grid(column=1, row= 5)
        self.yi.pack
        self.txi = Label(self.frame3, text = ' x\u1D62 ', font=('Arial',11))
        self.txi.grid(column=2, row=5)
        self.txi.pack
        self.xi = Entry(self.frame3, width=9, bg='Lightyellow')
        self.xi.grid(column=3, row=5)
        self.xi.pack
        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=RIDGE, bd=0)
        self.frame5.pack()
        self.brechnen = Button(self.frame5, height=2, width=6, text ='Rechnen', bd=5,
            command = self.kreisgerade)
        self.brechnen.pack(side=LEFT)

        self.bneu= Button(self.frame5, height=2, width=7, text ='Nächster\nSchnitt', bd=5,
            command = self.neuerschnitt)
        self.bneu.pack(side=LEFT)

        self.bneu = Button(self.frame5, height=2, width=4, text = "Neu", bd=5,
                command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, height=2, width=4, text = "Ende", fg='red', bd=5,
                command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Kreis-Geraden-Schnitt")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v06.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv06.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v06.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'
        self.yi.delete(0,END)
        self.xi.delete(0,END)

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def neuerschnitt(self):
        if self.marke == 1:
            self.y3.delete(0,END)
            self.x3.delete(0,END)
            self.y4.delete(0,END)
            self.x4.delete(0,END)
            self.yi.delete(0,END)
            self.xi.delete(0,END)
            self.y3.focus()
            self.anfangspunkt["text"] = "Gerade i (neue Eingabe)"
        self.lab2["text"] = ""
        self.lab2["fg"] = "black"
        self.warnzeichen()
        self.marke = 0

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def kreisgerade(self):
        if self.fenster.bind('<KeyPress>', self.taste):
            self.marke = 1
        try:
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            self.brechnen["text"] = 'Rechnen'

            fy1 = float(self.y1.get())
            fx1 = float(self.x1.get())
            fy2 = float(self.y2.get())
            fx2 = float(self.x2.get())
            if fy1 == fy2 and fx1 == fx2:
                self.lab1["text"] = "Fehler, Anfangs- gleich Endpunkt"
                self.lab1["fg"] = "red"
                self.lab2["text"] = ""
                self.warnzeichen()
                self.neu
                return
            fy3 = float(self.y3.get())
            fx3 = float(self.x3.get())
            fy4 = float(self.y4.get())
            fx4 = float(self.x4.get())

            fradius = float(self.radius.get())
            if fradius <= 0:
                self.lab1["text"] = "Radius darf nicht 0 \nund muss positiv sein!"
                self.lab1["fg"] = "red"
                self.lab2["text"] = ""
                return
            ft, fs = self.riwis(fy2 - fy1 , fx2 - fx1)
            fh = math.sqrt(fradius*fradius - fs*fs/4)
            fym = (fy1 + fy2)/2 + (fx2 - fx1)*fh/fs
            fxm = (fx1 + fx2)/2 - (fy2 - fy1)*fh/fs
            fhm, fjm, fsm = self.ortho((fy4-fy3), (fx4-fx3), (fym-fy3), (fxm-fx3))
            if abs(abs(fhm)- fradius) < 0.0003:
                self.tangente = True
                fhm=fradius
                fkm=0.
            elif abs(fhm) > fradius:
                self.lab2["text"] = "KEIN Schnitt!"
                self.lab2["fg"] = "red"
                return  
            else:
                fkm = math.sqrt(fradius*fradius - fhm*fhm)
                
            fyi = fy3 + (fy4-fy3)*(fjm+fkm)/fsm
            fxi = fx3 + (fx4-fx3)*(fjm+fkm)/fsm
            fs1=math.hypot(fy1-fyi, fx1-fxi)
            fs2=math.hypot(fy2-fyi, fx2-fxi)
            fh1, no1, no2 = self.ortho((fy4-fy3), (fx4-fx3), (fy1-fy3), (fx1-fx3))
            fh2, no1, no2 = self.ortho((fy4-fy3), (fx4-fx3), (fy2-fy3), (fx2-fx3))
            fh3, no1, no2 = self.ortho((fy2-fy1), (fx2-fx1), (fyi-fy1), (fxi-fx1))
            self.yi.delete(0,END)
            self.yi.insert(0, str(round(fyi,3)))
            self.xi.delete(0,END)
            self.xi.insert(0, str(round(fxi,3)))
            self.lab1["text"] = "Mittelpunkt y = {0:>8.3f}, x = {1:>8.3f}".format(fym, fxm) + \
                "\nSehne \u2081,\u2082 = " + str(round(fs,3))
            self.lab1["fg"] = "black"
            self.anfangspunkt["text"] = "Gerade i"
            ausgabe = "Sehne \u2081,\u1D62 = {0:>8.3f}\n".format(fs1)
            ausgabe += "Sehne \u2082,\u1D62 = {0:>8.3f} ".format(fs2)
            self.lab2["text"] = ausgabe
            self.lab2["fg"] = "black"
            if (fh3 >= 0.0003):
                ausgabe += "\nAußerhalb des Bogenstücks"
                self.lab2["fg"] = "red"    
            if abs(fh1) < 0.00002 or abs(fh2) < 0.00002:
                ausgabe +="\nSchnitt in einem der Bogenendpunkte"   
            if self.tangente == True:
                ausgabe +="\n Die Gerade ist eine Tangente!"
                self.tangente = False
            self.lab2["text"] = ausgabe
        except:
            self.lab2["text"] = "Falsches Zeichen, Radius zu klein,\nunerlaubt leeres Feld … ?"
            self.lab2["fg"] = "red"
            self.lab1["text"] = ""
            self.warnzeichen()

# Ende class KreisGerade():


#**************************************************************** 

class Kreisbogen(): #07

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400.: t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------
    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',11))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = " Kreisbogenteilung ",
            fg='blue', font=('Arial',12))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
            command = self.infobild) 
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack()
        self.anfangspunkt= Label(self.frame2, text = 'Ausgangsbogen',
            width = 20, font=('Arial',9))
        self.anfangspunkt.grid(column=0, columnspan=4, row=0, pady=4)
        self.anfangspunkt.pack
        self.tya= Label(self.frame2, text = ' y\u2090 ', font=('Arial',10))
        self.tya.grid(column=0, row=1)
        self.tya.pack 
        self.ya = Entry(self.frame2, width=9)
        self.ya.grid(column=1, row=1)
        self.ya.pack
        self.ya.focus()
        self.txa = Label(self.frame2, text = ' x\u2090 ', font=('Arial',10))
        self.txa.grid(column=2, row=1)
        self.txa.pack
        self.xa = Entry(self.frame2, width=9)
        self.xa.grid(column=3, row=1)
        self.xa.pack

        self.tye= Label(self.frame2, text = ' y\u2091 ', font=('Arial',10))
        self.tye.grid(column=0, row=3)
        self.tye.pack
        self.ye = Entry(self.frame2, width=9)
        self.ye.grid(column=1, row=3)
        self.ye.pack
        self.txe = Label(self.frame2, text = ' x\u2091 ', font=('Arial',10))
        self.txe.grid(column=2, row=3)
        self.txe.pack
        self.xe = Entry(self.frame2, width=9)
        self.xe.grid(column=3, row=3)
        self.xe.pack

        self.ttm = Label(self.frame2, text = 'Maßstabsfaktor', font=('Arial',9))
        self.ttm.grid(column=0, columnspan=3, row=4)
        self.ttm.pack
        self.massstabsfaktor = Entry(self.frame2, width=9)
        self.massstabsfaktor.grid(column=3, row=4, pady=2)
        self.massstabsfaktor.insert(0, "1")
        self.massstabsfaktor.pack

        self.tstr = Label(self.frame2, text = '  oder Strecke ', font=('Arial',9))
        self.tstr.grid(column=1, columnspan=2, row=5)
        self.tstr.pack
        self.strecke = Entry(self.frame2, width=9)
        self.strecke.grid(column=3, row=5, pady=4)
        self.strecke.pack

        self.tradius = Label(self.frame2, text = '            Radius ', font=('Arial',9))
        self.tradius.grid(column=1, columnspan=2, row=6)
        self.tradius.pack
        self.radius = Entry(self.frame2, width=9)
        self.radius.grid(column=3, row=6, pady=4)
        self.radius.pack

        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', fill = 'green')
        self.c.pack()

        self.frame3 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame3.pack()

        self.tanzahl = Label(self.frame3, text = 'Anzahl der Zwischenpunkte', width = 24, font=('Arial',9))
        self.tanzahl.grid(column=0, row=1, pady=2)
        self.tanzahl.pack
        self.anzahl = Entry(self.frame3, width=2)
        self.anzahl.grid(column=1, row=1, padx=5)
        self.anzahl.pack

        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=RIDGE,bd=0)
        self.frame5.pack()
        self.brechnen = Button(self.frame5, width=6, text ='Rechnen', bd=5,
            command = self.bogen)
        self.brechnen.pack(side=LEFT)

        self.bneu = Button(self.frame5, width=4, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, width=4, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def ortho(self, dye, dxe, dyi, dxi):
        re, se = self.riwis(dye, dxe)
        ri, si = self.riwis(dyi, dxi)
        wigon = ri - re
        hi = math.sin(wigon*math.pi/200.) * si
        ji = math.cos(wigon*math.pi/200.) * si
        return hi, ji

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel() 
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Kreisbogenteilung")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v07.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv07.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v07.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def bogen(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        try:
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            if self.strecke.get():
                fxe = float(self.strecke.get())
                fs = fxe
                fya = 0.
                fxa = 0.
                fye = 0.
                fmassstabsfaktor = 1
                self.massstabsfaktor.delete(0,END)
                self.massstabsfaktor.insert(0,'1')
                self.ya.delete(0,END)
                self.xa.delete(0,END)
                self.ye.delete(0,END)
                self.xe.delete(0,END)
            else:
                fya = float(self.ya.get())
                fxa = float(self.xa.get())
                fye = float(self.ye.get())
                fxe = float(self.xe.get())
                fmassstabsfaktor = float(self.massstabsfaktor.get())
                if fye == fya and fxe == fxa:
                    self.lab1["text"] = "Fehler, Anfangs- gleich Endpunkt"
                    self.lab1["fg"] = "red"
                    self.warnzeichen()
                    self.neu
                    return
                ft, fs = self.riwis((fye - fya), (fxe - fxa))
            fradius= float(self.radius.get())
            anzahl  = int(self.anzahl.get())
            if anzahl > 9:
                anzahl = 9
                self.anzahl.delete(0,END)
                self.anzahl.insert(0,"9")

            if 2*fradius < fs:
                self.lab1["text"] = "Radius zu klein"
                self.lab1["fg"] = "red"
                self.lab2["text"] = " "
                self.warnzeichen()
                self.marke = 1
                return

            fh = math.sqrt(fradius*fradius-fs*fs/4)
            fym = fya + (fye-fya)/2 - (fh*(fxe-fxa)/fs)
            fxm = fxa + (fxe-fxa)/2 + (fh*(fye-fya)/fs)

            fra, w  =  self.riwis((fya - fym), (fxa - fxm))
            fre, w  =  self.riwis((fye - fym), (fxe - fxm))
            fwinkel = fra-fre
            if fwinkel < 0: fwinkel + 400.
            fbae = fwinkel* math.pi * fradius/200.
            falpha = fwinkel/(anzahl+1)
            fbii = falpha * math.pi * fradius/200.

            fyi, fxi, fylokal, fxlokal = [],[],[],[]

            for q in range(0, anzahl+1):
                fyi.append('')
                fxi.append('')
                fylokal.append('')
                fxlokal.append('')
            fyi[0] = fya
            fxi[0] = fxa

            for i in range(1, anzahl+1):
                fyi[i] = fym + math.sin(((fra - i*falpha)* math.pi)/200.)*fradius
                fxi[i] = fxm + math.cos(((fra - i*falpha)* math.pi)/200.)*fradius
                fylokal[i], fxlokal[i] = self.ortho((fye - fya),(fxe - fxa), (fyi[i] - fya), (fxi[i] - fxa))
                fylokal[i] = fylokal[i]/fmassstabsfaktor
                fxlokal[i] = fxlokal[i]/fmassstabsfaktor

            fsii = math.hypot(fya-fyi[1], fxa - fxi[1])/fmassstabsfaktor

            ausgabe =" Nr.         yi             xi        y(lokal)  x(lokal)\n" +\
                " Anf.  {0:>8.3f}   {1:>8.3f}    {2:>8.3f}   {3:>8.3f}\n".format(fya, fxa, 0.,0.)
            for j in range(1, anzahl+1):
                ausgabe +=  "{0:>4}      {1:>8.3f}  {2:>8.3f}    {3:>8.3f}   {4:>8.3f}\n".format(j,fyi[j], fxi[j], fylokal[j], fxlokal[j])
            ausgabe += "Ende  {0:>8.3f}  {1:>8.3f}     {2:>8.3f}   {3:>8.3f}\n".format(fye, fxe,0., fs/fmassstabsfaktor)
            ausgabe += "\nSehne \u1D62,\u1D62\u208A\u2081 = {0:<8.3f}, Bogenlänge = {1:<8.3f}".format(fsii, fbii/fmassstabsfaktor)

            ausgabe2 = "Mittelpunkt y = {0:>8.3f}, x = {1:>8.3f}".format(fym, fxm)
            ausgabe2 +=  "\nSehne \u2090,\u2091 = {0:<8.3f}, Bogenlänge = {1:<8.3f}".format(fs, fbae)
            self.lab2["text"] = ausgabe
            self.lab2["fg"] = "black"
            self.lab1["text"] = ausgabe2
            self.lab1["fg"] = "black"
            self.brechnen["text"] = 'Rechnen'
        except:
            self.lab2["text"] = "Falsches Zeichen,\nunerlaubt leeres Feld … ?"
            self.lab2["fg"] = "red"
            self.warnzeichen()

# Ende class Kreisbogen():

#**************************************************************** 

class Flaeche(): #08

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "",
            font=('Arial',12))
        self.tueber.pack(side = RIGHT, pady=10)

        self.ueber = Label(self.frame, text = " Flächenberechnung ", fg='blue', font=('Arial',11))
        self.ueber.pack(fill="both", side= RIGHT, pady=10)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.tnn = Label(self.frame2, text = 'Anzahl der rechtsläufigen Eckpunkte\n (bis max. 12, Defaultwert = 3)', width = 30, font=('Arial',8))
        self.tnn.grid(column=0, columnspan=3, row=0, ipady=3)
        self.tnn.pack

        self.nn = Entry(self.frame2, width =2)
        self.nn.grid(column=3, row=0, padx=4)
        self.nn.delete(0,END)
        self.nn.insert(0, "3")
        self.nn.pack

        self.maxn = Button(self.frame2, width=2, text = "\u2714", fg='blue', bd=5,
            command = self.anzahl)
        self.maxn.grid(column=4, row=0)
        self.maxn.pack

        self.fenster.mainloop()
#----------------------------------------------------------------
    def segment(self, s, r):
        r = abs(r)
        alpha = 2* math.asin(0.5*s/r)
        sektor = alpha * r * r/2
        zw = (r*r) - (s*s/4.)
        segment = sektor - 0.5 *s * math.sqrt(zw)
        return segment

    def eingabe(self, anzahl):
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
            command = self.infobild) 
        self.binfo.pack(side=RIGHT)
        self.frame3 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame3.pack()
        self.text1 = Label(self.frame3, text = ' Nr.      y\u1D62           x\u1D62  \
Strecke\u1D62,\u1D62\u208A\u1D62 Radius\u1D62,\u1D62\u208A\u1D62 ', width=30, font=('Arial',10))
        self.text1.grid(column=0, columnspan=5, row=0)
        self.text1.pack

        self.yi, self.xi, self.si, self.ri = [], [], [], []

        for q in range(1, anzahl+1):
            self.yi.append(''); self.xi.append('')
            self.si.append(''); self.ri.append('')

        for i in range(1, anzahl+1):
            self.Nr = Label(self.frame3, text = i , font=('Arial',9))
            self.Nr.grid(column=0, row=i)

            self.yi[i-1] = Entry(self.frame3, width=9)
            self.yi[i-1].grid(column=1, row= i)
            self.yi[i-1].pack
            self.xi[i-1] = Entry(self.frame3, width=9)
            self.xi[i-1].grid(column=2, row= i)
            self.xi[i-1].pack
            self.si[i-1]= Entry(self.frame3, width=7, bg='yellow')
            self.si[i-1].grid(column=3, row= i)
            self.si[i-1].pack
            self.ri[i-1] = Entry(self.frame3, width=9)
            self.ri[i-1].grid(column=4, row= i)
            self.ri[i-1].pack

        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

        self.c = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.re = self.c.create_rectangle('0.1c','0c','5.5c','0.1c', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=RIDGE, bd=0)
        self.frame5.pack()
        self.brechnen= Button(self.frame5, width=8, text = 'Rechnen', bd=5,
            command = self.auswertung)
        self.brechnen.pack(side=LEFT)

        self.bneu = Button(self.frame5, width=4, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, width=8, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(side=LEFT)

#--------------------------------------------------------------------

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Flächenberechnung")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v08.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv08.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","DieGrafikdatei <v08.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen() 
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def anzahl(self):
        self.nni = int(self.nn.get())
        if self.nni > 12:
            self.nn.delete(0,END)
            self.nn.insert(0, "12")
            self.nni =12
        elif self.nni <3:
            self.nn.delete(0,END)
            self.nn.insert(0, "3")
            self.nni =3
        else:
            self.frame2.destroy()
            command  = self.eingabe(self.nni)

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def auswertung(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        self.tueber["text"] = " \u2713"
        self.tueber["fg"] = 'limegreen'
        try:
            self.fyi, self.fxi, self.ssi, self.sri = [],[],[],[]

            for q in range(1, self.nni+1):
                self.fyi.append(0.); self.fxi.append(0.)
                self.ssi.append(''); self.sri.append('')

            for i in range(1,self.nni+1):
                self.fyi[i-1] = float(self.yi[i-1].get())
                self.fxi[i-1] = float(self.xi[i-1].get())
                self.sri[i-1] = self.ri[i-1].get()
            flaeche = 0

            for i in range(1,self.nni+1):
                if i == 1:
                    fa = self.fxi[0] * (self.fyi[1] - self.fyi[self.nni-1])
                    fs = math.hypot(self.fxi[1] - self.fxi[0], self.fyi[1] - self.fyi[0])
                    self.si[0].delete(0,END)
                    self.si[0].insert(0, str(round(fs,3)))

                    if self.ri[0].get():
                        fr = float(self.sri[0])
                        if fr < 0:
                            fa =fa - 2*self.segment(fs,fr)
                        else:
                            fa = fa + 2*self.segment(fs,fr)

                elif i == self.nni:
                    fa = self.fxi[self.nni-1] * (self.fyi[0] - self.fyi[self.nni-2])
                    fs = math.hypot(self.fxi[0] - self.fxi[self.nni-1], self.fyi[0] - self.fyi[self.nni-1])
                    self.si[self.nni-1].delete(0,END)
                    self.si[self.nni-1].insert(0, str(round(fs,3)))
                    if self.ri[self.nni-1].get():
                        fr = float(self.sri[self.nni-1])
                        if fr < 0:
                            fa = fa - 2*self.segment(fs,fr)
                        else:
                            fa = fa + 2*self.segment(fs,fr)
                else:
                    fa = self.fxi[i-1] * (self.fyi[i] - self.fyi[i-2])
                    fs = math.hypot(self.fxi[i] - self.fxi[i-1], self.fyi[i] - self.fyi[i-1])
                    self.si[i-1].delete(0,END)
                    self.si[i-1].insert(0, str(round(fs,3)))
                    if self.ri[i-1].get():
                        fr = float(self.sri[i-1])
                        if fr < 0:
                            fa = fa - 2*self.segment(fs,fr)
                        else:
                            fa = fa + 2*self.segment(fs,fr)
                flaeche = flaeche + fa/2

                self.lab1["text"] = "Fläche = "  + str(round(flaeche, 3))
                self.lab1["fg"] = "black"
                self.lab1["font"] = 'Arial',11
                self.brechnen["text"] = 'Rechnen'
        except:
            self.lab1["text"] = "Falsches Zeichen, unerlaubt leeres Feld,\nRadius zu klein … ?"
            self.lab1["fg"] = "red"
            self.lab1["font"] = 'Arial',9
            self.warnzeichen()

# Ende class Flaeche():

#--------------------------------------------------------------------

class Polygonzug(): #09

    def initial (self):
        self.fdrehung = 0. # Drehwinkel auf Anfangspunkt
        self.winkelanschluss = True
        self.abschluss = True
        self.abschlussfehler = False
        self.winkelabschluss = True
        self.ringpolygon = False
        self.trans = False #Schalter ohne/mit Transformation

    def __init__(self):
        self.initial()
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster, width=120)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "",
            font=('Arial',12))
        self.tueber.pack(side = RIGHT, pady=10)

        self.ueber = Label(self.frame, text = " Polygonzug ", fg='blue', font=('Arial',12))
        self.ueber.pack(fill="both", side= RIGHT, pady=10)
        
        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=2)
        self.frame2.pack()
        self.tnn = Label(self.frame2, text = 'Anzahl der Neu- bzw.\nZwischenpunkte\n (bis max. 6, Default = 1)', width = 25, font=('Arial',8))
        self.tnn.grid(column=0, columnspan=3, row=0)
        self.tnn.pack

        self.nn = Entry(self.frame2, width =2)
        self.nn.grid(column=3, row=0, padx=5)
        self.nn.delete(0,END)
        self.nn.insert(0, "1")
        self.nn.pack

        self.maxn = Button(self.frame2, width=2, text = "\u2714", fg='blue', bd=5,
            command = self.anzahl)
        self.maxn.grid(column=4, row=0)
        self.maxn.pack

        self.tmax = Label(self.frame2, text = 'Maximaler Abschlussfehler ', width = 25, font=('Arial',8))
        self.tmax.grid(column=0, columnspan=3, row=3)
        self.tmax.pack
        
        self.schlussfehler = Entry(self.frame2, width =4)
        self.schlussfehler.grid(column=3, row=3)
        self.schlussfehler.delete(0,END)
        self.schlussfehler.insert(0,"0.1")
        self.schlussfehler.pack

        self.fenster.mainloop()
#-----------------------------------------------------------------
    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400.: t = 0
        s = math.hypot(dy, dx)
        return t, s
#-----------------------------------------------------------------------
    def eingabe(self):
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)
        self.frame5 = Frame(self.fenster, relief=RIDGE,bd=0)
        self.frame5.pack()
        self.button1= Button(self.frame5, width=9, height=1, text ='Rechnen', bd=5,
            command = self.trans1)
        self.button1.pack(side=LEFT)

        self.button2= Button(self.frame5, width=11, height=1, text ='Transformation', bd=5,
            command = self.trans2)
        self.button2.pack(side=LEFT)

        self.bneu = Button(self.frame5, width=3, height=1, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame5, width=4, height=1,text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(side=LEFT)
        
        self.frame2 = Frame(self.fenster, pady=2, padx=2, relief=RIDGE,bd=5)
        self.frame2.pack()
        self.anfangspunkt= Label(self.frame2, text = 'Anschlusspunkte',
            width = 25, font=('Arial',11))
        self.anfangspunkt.pack
        self.anfangspunkt.grid(columnspan=4, row=0, padx=2, pady=2)

        self.ttfa1 = Label(self.frame2, text = ' Anschlussrichtung ', font=('Arial',9))
        self.ttfa1.pack
        self.ttfa1.grid(columnspan=2, column=0, row=1)

        self.ttfa2 = Label(self.frame2, text = ' tF,\u2090', font=('Arial',11))
        self.ttfa2.pack
        self.ttfa2.grid( column=2, row=1)
                       
        self.tfa = Entry(self.frame2, width=9)
        self.tfa.pack
        self.tfa.grid(column=3, row=1)
        
        self.tyaf = Label(self.frame2, text = ' y\u2090 F', font=('Arial',11))
        self.tyaf.pack
        self.tyaf.grid(column=0, row=2)
        self.yaf = Entry(self.frame2, width=9)
        self.yaf.pack
        self.yaf.grid(column=1, row=2)
        self.txaf = Label(self.frame2, text = ' x\u2090 F', font=('Arial',11))
        self.txaf.grid(column=2, row=2)
        self.txaf.pack
        self.xaf = Entry(self.frame2, width=9)
        self.xaf.grid(column=3, row=2)
        self.xaf.pack

        self.tya= Label(self.frame2, text = ' y\u2090', font=('Arial',11))
        self.tya.pack
        self.tya.grid(column=0, row=3)
        self.ya = Entry(self.frame2, width=9)
        self.ya.pack
        self.ya.grid(column=1, row=3)
        self.txa = Label(self.frame2, text = ' x\u2090', font=('Arial',11))
        self.txa.grid(column=2, row=3)
        self.txa.pack
        self.xa = Entry(self.frame2, width=9)
        self.xa.grid(column=3, row=3)
        self.xa.pack
        self.tba= Label(self.frame2, text = ' \u03B2\u2090', font=('Arial',11))
        self.tba.pack
        self.tba.grid(column=0, row=4)
        self.ba = Entry(self.frame2, width=9)
        self.ba.pack
        self.ba.grid(column=1, row=4)
        self.tsa = Label(self.frame2, text = ' s\u2090,\u2081', font=('Arial',11))
        self.tsa.grid(column=2, row=4)
        self.tsa.pack
        self.sa = Entry(self.frame2, width=9)
        self.sa.grid(column=3, row=4, padx=10, pady=2)
        self.sa.pack

        self.frame3 = Frame(self.fenster, pady=2, relief=RIDGE, bd=5)
        self.frame3.pack()
        self.text1 = Label(self.frame3, text = ' Nr.   \u03B2\u1D62       Seite \u1D62    \
      y\u1D62              x\u1D62     ', width =29, font=('Arial',10))
        self.text1.pack
        self.text1.grid(column=0, columnspan=5, row=0)

        self.bi, self.si, self.yi, self.xi, self.ri = [], [], [], [], []

        for q in range(self.nni+2):
            self.bi.append(''); self.si.append(''), self.si.append(0)
            self.yi.append(''); self.xi.append('')

        for i in range(1,self.nni+1):
            self.Nr = Label(self.frame3, text = i , font=('Arial',9))
            self.Nr.grid(column=0, row=i)

            self.bi[i] = Entry(self.frame3, width = 8)
            self.bi[i].grid(column=1, row= i)
            self.bi[i].pack

            self.si[i] = Entry(self.frame3, width = 8)
            self.si[i].grid(column=2, row= i)
            self.si[i].pack

            self.yi[i]= Entry(self.frame3, width = 9, bg='Lightyellow')
            self.yi[i].grid(column=3, row= i)
            self.yi[i].pack

            self.xi[i] = Entry(self.frame3, width = 9, bg='Lightyellow')
            self.xi[i].grid(column=4, row= i)
            self.xi[i].pack

        self.frame4 = Frame(self.fenster, padx=3, relief=RIDGE, bd=5)
        self.frame4.pack()
        self.endpunkt= Label(self.frame4, text = 'Abschlusspunkte',
            width = 25, font=('Arial',11))
        self.endpunkt.pack
        self.endpunkt.grid(columnspan=4, row=0)
        self.tbe = Label(self.frame4, text = ' \u03B2\u2091', font=('Arial',11))
        self.tbe.pack
        self.tbe.grid(column=0, row=1)
        self.be = Entry(self.frame4, width=9)
        self.be.pack
        self.be.grid(column=1, row=1)

        self.ttef = Label(self.frame4, text = ' t\u2091, F', font=('Arial',11))
        self.ttef.pack
        self.ttef.grid( column=2, row=1)

        self.tef = Entry(self.frame4, width=9)
        self.tef.pack
        self.tef.grid(column=3, row=1)

        self.tye = Label(self.frame4, text = ' y\u2091', font=('Arial',11))
        self.tye.pack
        self.tye.grid(column=0, row=2)
        self.ye = Entry(self.frame4, width=9)
        self.ye.pack
        self.ye.grid(column=1, row=2)
        self.txe = Label(self.frame4, text = ' x\u2091', font=('Arial',11))
        self.txe.grid(column=2, row=2)
        self.txe.pack
        self.xe = Entry(self.frame4, width=9)
        self.xe.grid(column=3, row=2)
        self.xe.pack
        self.tyef = Label(self.frame4, text = ' y\u2091 F' , font=('Arial',11))
        self.tyef.pack
        self.tyef.grid(column=0, row=3)
        self.yef = Entry(self.frame4, width=9)
        self.yef.pack
        self.yef.grid(column=1, row=3)
        self.txef = Label(self.frame4, text = ' x\u2091 F', font=('Arial',11))
        self.txef.grid(column=2, row=3)
        self.txef.pack
        self.xef = Entry(self.frame4, width=9)
        self.xef.grid(column=3, row=3)
        self.xef.pack
        self.tma = Label(self.frame4, text = ' Maßstab vor Transformation ', font=('Arial',9))
        self.tma.grid(column=0,columnspan=3, row=4)
        self.tma.pack
        self.massstab = Entry(self.frame4, width=9)
        self.massstab.grid(column=3, row=4, padx=6, pady=0)
        self.massstab.delete(0,END)
        self.massstab.insert(0, "1")
        self.massstab.pack

        self.lab1 = Label(self.fenster, text = '')
        self.lab1.pack()

#-----------------------------------------------------------------

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            Label(self.newWindow, text =("Polygonzug")).pack()
            self.newWindow.attributes("-topmost", 1)
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v09.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv09.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v09.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.initial()
        self.__init__()

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def taste(self, event):
        self.fdrehung = 0.
        self.trans = False
        self.button1["text"] = 'Neu rechnen' 
        self.warnzeichen()   

    def anzahl(self):
       self.nni = int(self.nn.get())
       self.fschlussfehler = float(self.schlussfehler.get())
       if self.nni > 6:
           self.nn.delete(0,END)
           self.nn.insert(0, "6")
           self.nni = 6
       elif self.nni < 1:
           self.nn.delete(0,END)
           self.nn.insert(0, "1")
           self.nni = 1
       else:
           self.frame2.destroy()
           command = self.eingabe()

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def trans1(self):  #Rechnen
        if self.trans == True:
            return
        for i in range(1,self.nni+1):
            self.yi[i].delete(0,END)
            self.xi[i].delete(0,END)
        self.fdrehung = 0.
        self.fmassstab = float(self.massstab.get())
        self.fmassstab_alt = self.fmassstab  
        self.tueber["text"] = " \u2713"
        command = self.transform()
        self.trans = True

    def trans2(self): #Transformation
        if self.abschluss == False:
            return
        for i in range(1,self.nni+1):
            self.yi[i].delete(0,END)
            self.xi[i].delete(0,END)
        
        if self.trans == False:
            self.lab1["text"] = "Erst Rechnen drücken!"
            self.warnzeichen()
            return
        
        self.trans = True

        if self.ringpolygon == False:
             try:
                 self.fdrehung = self.ftae_soll - self.ftae_ist
                 self.fmassstab = self.fsae_soll/(self.fsae_ist/self.fmassstab_alt)
             except:
                 self.lab1["text"] = "Falsches Zeichen, unerlaubt leeres Feld\nKonfiguration irregulär … ?"
                 self.lab1["fg"] = "red"
                 self.warnzeichen()
                 self.trans = False
                 return
        self.tueber["text"] = " \u2713\u2713"
        command = self.transform()
        self.button1["text"] = 'Rechnen'
        self.trans = False
        self.initial()
        return

    def transform(self):
        self.tueber["fg"] = 'limegreen'
        self.fenster.bind('<KeyPress>', self.taste)
        try:
            self.fbi, self.fti, self.fsi, self.fyi, self.fxi = [],[],[],[],[]

            for q in range(self.nni+2):
                self.fbi.append(0.); self.fti.append(0.); self.fsi.append(0.)
                self.fyi.append(0.); self.fxi.append(0.)

            try:    #Anschluss
                self.fyi[0] = float(self.ya.get())
                self.fxi[0] = float(self.xa.get())
                self.fbi[0] = float(self.ba.get())
                self.fsi[0] = float(self.sa.get())
                if self.fbi[0] == 0 : self.winkelanschluss = False
                else:
                    self.winkelanschluss = True
                    if self.tfa.get().strip():
                        ftfa = float(self.tfa.get())
                    else:
                        fyaf = float(self.yaf.get())
                        fxaf = float(self.xaf.get())
                        ftfa, fsfa = self.riwis(self.fyi[0] - fyaf, self.fxi[0] - fxaf)
            except:
                 self.lab1["fg"] = "red"
                 self.warnzeichen()
                 self.lab1["text"] = "Anschlussdaten nicht vollständig\noder inkorrekt!"
                 return

            try:    #Abschluss
                fye = float(self.ye.get())
                fxe = float(self.xe.get())
                if fye == self.fyi[0] and fxe == self.fxi[0]:
                    self.ringpolygon = True
                    if self.winkelanschluss == False:
                         self.lab1["fg"] = "red"
                         self.warnzeichen()
                         self.lab1["text"] = "\nRingpolygon ohne Winkelanschluss\n nicht berechenbar!"
                         return
                else:
                    self.ringpolygon = False
                if fye == 0 and fxe == 0:
                    self.abschluss = False
                    self.winkelabschluss = False
                else:    
                    fbe = float(self.be.get())
                    if fbe == 0:
                        self.winkelabschluss = False
                    else:
                        self.winkelabschluss = True
                if self.winkelabschluss == True:
                    try:
                        if self.tef.get().strip():
                            ftef = float(self.tef.get())
                        else:                                
                            fyef = float(self.yef.get())
                            fxef = float(self.xef.get())
                            ftef, fsfe = self.riwis(fyef - fye, fxef - fxe)
                        self.ftae_soll, self.fsae_soll = self.riwis(fye - self.fyi[0], fxe - self.fxi[0])
                    except:
                        self.lab1["fg"] = "red"
                        self.warnzeichen()
                        self.lab1["text"] = "Abschlussdaten nicht vollständig!"
                        return
            except:
                self.lab1["fg"] = "red"
                self.warnzeichen()
                self.lab1["text"] = "Abschlussdaten nicht vollständig\noder inkorrekt!"
                return

            if self.ringpolygon == False or self.abschluss == True:
                self.ftae_soll, self.fsae_soll = self.riwis(fye - self.fyi[0], fxe - self.fxi[0])

            if self.winkelanschluss == True:
                self.fti[0] = ftfa + self.fdrehung + self.fbi[0] -200.
            else:
                self.fti[0] = self.ftae_soll + self.fdrehung  #Näherung im 1. Durchlauf
            if self.fti[0] >= 400. : self.fti[0] -=400.   

            self.summesi = self.fsi[0]
            for i in range(1,self.nni+1):
                self.fsi[i] = float(self.si[i].get())
                self.summesi += self.fsi[i]
                self.fbi[i] = float(self.bi[i].get())
                self.fyi[i] = self.fyi[i-1] + self.fsi[i-1]* self.fmassstab* math.sin(self.fti[i-1]*math.pi/200.)
                self.fxi[i] = self.fxi[i-1] + self.fsi[i-1]* self.fmassstab* math.cos(self.fti[i-1]*math.pi/200.)
                self.fti[i] = self.fti[i-1] + self.fbi[i] - 200.
                if self.fti[i] >= 400.: self.fti[i] -= 400.
                if self.fti[i] < 0.: self.fti[i] += 400.
            self.fyi[self.nni+1] = self.fyi[self.nni] + self.fsi[self.nni]* self.fmassstab* math.sin(self.fti[self.nni]*math.pi/200.)
            self.fxi[self.nni+1] = self.fxi[self.nni] + self.fsi[self.nni]* self.fmassstab* math.cos(self.fti[self.nni]*math.pi/200.)

            if self.trans == True:
                if self.ringpolygon == True:
                    fteilsumme = 0.
                    for i in range(1,self.nni+2):
                        fteilsumme =  fteilsumme + self.fsi[i-1]/self.summesi
                        self.fyi[i] += self.ffy * fteilsumme
                        self.fxi[i] += self.ffx * fteilsumme 

            for i in range(1,self.nni+1):
                self.yi[i].insert(0, str(round(self.fyi[i],3)))
                self.xi[i].insert(0, str(round(self.fxi[i],3)))
            if self.abschluss == True:
                if self.winkelabschluss == True:
                    self.fti[self.nni+1] = self.fti[self.nni] + fbe - 200.
                    if self.fti[self.nni+1] >= 400. : self.fti[self.nni+1] -=400.
                    FW = ftef - self.fti[self.nni+1]
                self.ftae_ist, self.fsae_ist = self.riwis(self.fyi[self.nni+1] - self.fyi[0], self.fxi[self.nni+1] - self.fxi[0])
                if self.ringpolygon == False:
                    self.fdrehung = self.ftae_soll - self.ftae_ist
                self.ffy = fye - self.fyi[self.nni+1]
                self.ffx = fxe - self.fxi[self.nni+1]
                self.ffxy = math.hypot(self.ffx, self.ffy)
                if self.ringpolygon == False:
                    self.FL = self.fsae_soll - self.fsae_ist   #Längsabweichung
                    self.FQ = self.fsae_soll * math.sin(self.fdrehung *math.pi/200.)  #Querabweichung
            self.lab1["text"] = ""
            self.lab1["fg"] = "blue"
            if self.trans == False:
                if self.abschluss == False:
                    self.lab1["text"] = "Gerechnet mit Maßstabsfaktor = 1\n\
Transformation nicht erforderlich oder machbar\nohne Koordinatenabschluss \u2B62  y\u2091, x\u2091 gerechnet"
                    self.ye.delete(0,END)
                    self.xe.delete(0,END)
                    self.ye.insert(0, str(round(self.fyi[self.nni+1],3)))
                    self.xe.insert(0, str(round(self.fxi[self.nni+1],3)))
                    self.ye["bg"] = "Lightyellow"
                    self.xe["bg"] = "Lightyellow"
                    self.tueber["text"] = " \u2713\u2713"
                    self.trans == True
                    return

            if self.abschluss == True:
                self.lab1["text"] += "Koordinatenabschluss   fy = " +\
                          str(round(self.ffy, 3)) + ", fx = " + str(round(self.ffx, 3)) +"\n"
            
            if self.winkelabschluss == True:
                    self.lab1["text"] += "f\u03B2 = "  + str(round(FW, 4))+ " gon,   "
            else:
                self.lab1["text"] += "ohne Winkelabschluss\n"

            if self.ringpolygon == False:
                self.lab1["text"] += "L = " + str(round(self.FL, 3))
                self.lab1["text"] += ",   W = " + str(round(self.FQ, 3))
            else:
                self.lab1["text"] += "    Ringpolygon"
            if abs(self.ffy) > self.fschlussfehler or abs(self.ffx) > self.fschlussfehler or self.ffxy > self.fschlussfehler:
                self.f1y = self.ffy;   self.f1x = self.ffx
                self.abschlussfehler = True
            else:
                self.abschlussfehler = False
            if self.winkelanschluss == False:
                self.lab1["text"] += "\nohne Winkelanschluss"

            if self.trans == False:
                self.lab1["text"] += "\nGerechnet mit Maßstabsfaktor = " + str(round (self.fmassstab,7)) +\
                "\nKoordinaten ohne Fehlerverteilung"
                if self.abschluss == True and self.ringpolygon == False:
                    self.lab1["text"] += "\nNoch keine Transformation gerechnet"
                elif self.ringpolygon == True:
                    self.lab1["text"] += "\nFehlerverteilung: Drücke Transformation"
                if self.abschlussfehler == True:
                    self.windowabschluss= Toplevel()
                    self.windowabschluss.title("")
                    self.frame99 = Frame(self.windowabschluss, relief=GROOVE, bd=7)
                    self.frame99.pack()
                    Label(self.frame99, text = ("\n\u26A0 Warnung"), width= 20, bd=2, relief=FLAT, font=('Arial',11), fg='red').pack()                   
                    Label(self.frame99, text = ("Der voreingestellte maximale\nAbschlussfehler ist im ersten Durchlauf\nüberschritten. \
Eine Transformation bzw.\nFehlerverteilung ist trotzdem möglich!\n"), font=('Arial',9), fg='black').pack()
                    self.but = Button(self.frame99, width=12, text ='\u2573  Schließen', bg='red', fg ='white',relief=GROOVE,command  = self.windowabschluss.destroy)
                    self.but.pack(side=RIGHT)
                    self.windowabschluss.attributes("-topmost", True)                            
            else:
                self.lab1["text"] += "\nGerechnet mit Maßstabsfaktor = " + str(round (self.fmassstab,7))      
                if self.ringpolygon == True:
                    self.lab1["text"] += "\nFehlerverteilung nach Seitenlängen"
                    self.lab1["text"] += "\nEndgültige Koordinaten" 
                else:
                    self.lab1["text"] += "\nTransformation gerechnet"
            return
        except:
            self.lab1["text"] = "Falsches Zeichen, unerlaubt leeres Feld\nKonfiguration irregulär … ?"
            self.lab1["fg"] = "red"
            self.warnzeichen()
            self.trans = False
            return

# Ende  class Polygonzug():
#********************************************************************

class Streckenreduktion():  #10

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack(padx=2)
        self.tueber = Label(self.frame, text = "",
                          font=('Arial',12))
        self.tueber.pack( side = RIGHT, pady=10)
        self.ueber = Label(self.frame, text = "Streckenreduktion örtlich \u27F9 UTM",
                           fg='blue', font=('Arial',10))
        self.ueber.pack(pady=10)

        self.frame1 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame1.pack()
        self.t1 = Label(self.frame1, text = 'gemessene Schrägstrecke', font=('Arial',9))
        self.t1.grid(column=0, columnspan=2, row=0)
        self.t1.pack
        self.schraegstrecke = Entry(self.frame1, width=9)
        self.schraegstrecke.grid(column=2, row=0)
        self.schraegstrecke.focus()
        self.schraegstrecke.pack

        self.t2 = Label(self.frame1, text = 'Zenitdistanz [gon]', font=('Arial',9))
        self.t2.grid(column=0, columnspan=2, row=1)
        self.t2.pack
        self.zenitdistanz = Entry(self.frame1, width=9)
        self.zenitdistanz.grid(column=2, row=1)
        self.zenitdistanz.pack

        self.t3 = Label(self.frame1, text = 'Additionskonstante', font=('Arial',9))
        self.t3.grid(column=0, columnspan=2, row=2)
        self.t3.pack
        self.additionskonstante = Entry(self.frame1, width=9)
        self.additionskonstante.grid(column=2, row=2)
        self.additionskonstante.insert(0, "0.0")
        self.additionskonstante.pack

        self.t4 = Label(self.frame1, text = 'linearer Maßstabsfaktor', font=('Arial',9))
        self.t4.grid(column=0, columnspan=2, row=3)
        self.t4.pack
        self.massstab = Entry(self.frame1, width=9)
        self.massstab.grid(column=2, row=3)
        self.massstab.insert(0, "1.0")
        self.massstab.pack

        self.t5 = Label(self.frame1, text = '', font=('Arial',9))
        self.t5.grid(column=0, columnspan=3, row=4, pady=2)
        self.t5.pack

        self.t6 = Label(self.frame1, text = '\u2500'*40, font=('Arial',4))
        self.t6.grid(column=0, columnspan=3, row=5)
        self.t6.pack

        self.t7 = Label(self.frame1, text = 'Höhe über NHN [m]\n(Defaultwert = 100)', font=('Arial',9))
        self.t7.grid(column=0, columnspan=2, row=6)
        self.t7.pack
        self.hoehe = Entry(self.frame1, width=7)
        self.hoehe.grid(column=2, row=6)
        self.hoehe.pack

        self.t8 = Label(self.frame1, text = 'Quasigeoidundulation [m]\n(Defaultwert = 46.5)', font=('Arial',9))
        self.t8.grid(column=0, columnspan=2, row=7)
        self.t8.pack
        self.hoehe2 = Entry(self.frame1,  width=7)
        self.hoehe2.grid(column=2, row=7, pady=2)
        self.hoehe2.insert(0, "46.5")
        self.hoehe2.pack

        self.t9 = Label(self.frame1, text = '', font=('Arial',9))
        self.t9.grid(column=0, columnspan=3, row=8)
        self.t9.pack

        self.t10 = Label(self.frame1, text = '\u2500'*40, font=('Arial',4))
        self.t10.grid(column=0, columnspan=3, row=9)
        self.t10.pack

        self.t11 = Label(self.frame1, text = 'Mittl. Ostwert (<> 500 [km])', font=('Arial',9))
        self.t11.grid(column=0, columnspan =2, row=10)
        self.t11.pack
        self.most = Entry(self.frame1, width=7)
        self.most.grid(column=2, row=10, pady=4)
        self.most.pack

        self.c = Canvas(self.fenster, width='5.0c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.0c','0.1c', fill = 'green')
        self.c.pack(pady=6)

        self.t12 = Label(self.fenster, text = '')
        self.t12.pack()
        self.t13 = Label(self.fenster, text = '')
        self.t13.pack()

        self.c = Canvas(self.fenster, width='5.0c', height='0.3c', relief=FLAT) 
        self.rec = self.c.create_rectangle('0.1c','0c','5.0c','0.1c', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=FLAT, bd=0)
        self.frame5.pack()
        self.brechnen = Button(self.frame5, height=2, width=6, text = 'Rechnen', bd=5,\
            command = self.strecke)
        self.brechnen.pack(side=LEFT)

        self.neuestrecke = Button(self.frame5, height=2, width=6, text = 'Neue\nStrecke', bd=5,\
          command = self.neuestrecke)
        self.neuestrecke.pack(side=LEFT)

        self.bloeschen = Button(self.frame5, height=2, width=6, text = "Löschen", bd=5,
          command = self.loeschen)
        self.bloeschen.pack(side=LEFT)

        self.bende = Button(self.frame5, height=2, width=4, text = "Ende", fg='red',bd=5,
          command = self.ende)
        self.bende.pack(side=LEFT)
        self.fenster.mainloop()

    def neuestrecke(self):
        self.schraegstrecke.delete(0,END)
        self.schraegstrecke.insert(0, " ")
        self.zenitdistanz.delete(0,END)
        self.zenitdistanz.insert(0, " ")

    def loeschen(self):
        self.fenster.destroy()
        self.__init__()

    def taste(self, event):
        if self.marke == 0:
            self.tueber["text"] = " \u26A0"
            self.tueber["fg"] = 'red'
        self.marke = 1
        self.brechnen["text"] = 'Erneut\nRechnen'

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def ende(self):
        self.fenster.destroy()

    def strecke(self):
        try:
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            self.brechnen["text"] = 'Rechnen'
            fsschraeg = float(self.schraegstrecke.get())
            if self.zenitdistanz.get().strip():
                fzenit = float(self.zenitdistanz.get())
            else:
                fzenit = 100.
                self.zenitdistanz.insert(0, "100.0")

            fadd = float(self.additionskonstante.get())
            fmass = float(self.massstab.get())
            fshoriz =(fadd + fmass * fsschraeg) * math.sin(math.pi*fzenit/200.)

            if self.hoehe.get().strip():
                fhoehe = float(self.hoehe.get())
            else:
                fhoehe = 100.
                self.hoehe.insert(0, "100.0")

            fhoehe2 =  float(self.hoehe2.get())
            fr = 6381. # Erdradius für NRW in [km]
            fsrechenebene = fshoriz *(1. - (fhoehe + fhoehe2) * 0.001/fr)
            fkorrekturutm = 0.9996 * (1. + (float(self.most.get()) - 500.)**2/(2.* fr * fr))
            fkorrektur= fkorrekturutm - 0.9996 *(fhoehe + fhoehe2) * 0.001/fr
            fsutm = fshoriz * fkorrektur
            self.t5["text"] = "\u27f9 horizontierte Strecke = " +str(round(fshoriz,3))
            self.t5["fg"] = "green"
            self.t9["text"] = "\u27f9 Strecke auf Rechenebene = " +str(round(fsrechenebene,3))
            self.t9["fg"] = "green"
            self.t12["text"] = "Def.: Strecke (hor.) \u00D7 r =  Strecke (UTM)"
            self.t12["text"] += "\nRed.-Faktor (nur UTM)     r = " + str(round(fkorrekturutm,7))
            self.t12["text"] += "\nRed.-Faktor (Höhe, UTM) r = " + str(round(fkorrektur,7))
            self.t12["fg"] = "green"
            self.t13["text"] = " \n\u27f9 UTM-Strecke = " +  str(round(fsutm,3))
            self.t13["font"] ='Arial',10
            if self.fenster.bind('<KeyPress>',self.taste):
                self.marke = 0

        except:
            self.t9["text"] = "Fehlerhafte Eingabe\n (z.B. Falsches Zeichen, Ostwert ?"
            self.t9["fg"] = "red"
            self.warnzeichen()

# Ende class Streckenreduktion()

#****************************************************************

class StreckeUTM(): #11

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack(padx=2)
        self.tueber = Label(self.frame, text = "",
            font=('Arial',12))
        self.tueber.pack( side = RIGHT, pady=10)
        self.ueber = Label(self.frame, text = "Strecke UTM \u27F9 örtlich",
            fg='blue', font=('Arial',12))
        self.ueber.pack( pady=10)

        self.frame2 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack()
        self.ausgang = Label(self.frame2, text = 'Ausgangsstrecke in UTM',
             width =20, font=('Arial',9))
        self.ausgang.grid(column=0,columnspan=3, padx=2, pady=2, row=0)
        self.ausgang.pack
        self.strecke = Entry(self.frame2, width=9)
        self.strecke.grid(column=3, row=0)
        self.strecke.focus()
        self.strecke.pack 
        self.ts = Label(self.frame2, text = 'oder aus Koordinaten', font=('Arial',9))
        self.ts.grid(column=0,columnspan=4, row=1)
        self.ts.pack
        self.ty1= Label(self.frame2, text = 'Ost\u2081', font=('Arial',9))    
        self.ty1.grid(column=0, row=2)
        self.ty1.pack 
        self.y1 = Entry(self.frame2, width=9)
        self.y1.grid(column=1, row=2)
        self.y1.pack
        self.tx1 = Label(self.frame2, text = '  Nord\u2081', font=('Arial',9))
        self.tx1.grid(column=2, row=2)
        self.tx1.pack
        self.x1 = Entry(self.frame2, width=9)
        self.x1.grid(column=3, row=2)
        self.x1.pack
        self.ty2= Label(self.frame2, text = 'Ost\u2082', font=('Arial',9))   
        self.ty2.grid(column=0, row=3)
        self.ty2.pack
        self.y2 = Entry(self.frame2, width=9)
        self.y2.grid(column=1, row=3)
        self.y2.pack
        self.tx2 = Label(self.frame2, text = '  Nord\u2082', font=('Arial',9))
        self.tx2.grid(column=2, row=3)
        self.tx2.pack
        self.x2 = Entry(self.frame2, width=9)
        self.x2.grid(column=3, row=3)
        self.x2.pack

        self.txe = Label(self.frame2, text = '\u2500'*40, font=('Arial',4))
        self.txe.grid(column=0, columnspan=4, row=4)
        self.txe.pack
        self.tx3 = Label(self.frame2, text = 'Höhe über NHN [m]\n(Default = 100)', font=('Arial',9))
        self.tx3.grid(column=1, columnspan=2,  row=5)
        self.tx3.pack
        self.hoehe = Entry(self.frame2, width=7)
        self.hoehe.grid(column=3, row=5)
        self.hoehe.pack

        self.tx3 = Label(self.frame2,  text = ' Quasigeoidundulation [m]\n(Default = 46.5)', font=('Arial',9))
        self.tx3.grid(column=0, columnspan=3, row=6)
        self.tx3.pack
        self.hoehe2 = Entry(self.frame2, width=7)
        self.hoehe2.grid(column=3, row=6)
        self.hoehe2.insert(0, "46.5")
        self.hoehe2.pack

        self.tx3 = Label(self.frame2,  text = 'Mittl. Ostwert in [km]', font=('Arial',9))
        self.tx3.grid(column=1, columnspan=2,  row=8)
        self.tx3.pack
        self.most = Entry(self.frame2, width=7)
        self.most.grid(column=3, row=8, pady=2)
        self.most.pack

        self.c = Canvas(self.fenster, width='5.0c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.0c','0.1c', fill = 'green')
        self.c.pack(pady=6)

        self.lab2 = Label(self.fenster, text = '')
        self.lab2.pack()
        self.lab3 = Label(self.fenster, text = '')
        self.lab3.pack()
        
        self.c = Canvas(self.fenster, width='5.0c', height='0.3c', relief=FLAT)
        self.rec = self.c.create_rectangle('0.1c','0c','5.0c','0.1c', fill = 'blue')
        self.c.pack()

        self.frame5 = Frame(self.fenster, relief=FLAT,bd=0)
        self.frame5.pack()
        self.brechnen = Button(self.frame5, height=2, width=6, text ='Rechnen', bd=5,
            command = self.rechnen)
        self.brechnen.pack(side=LEFT)

        self.neuestrecke = Button(self.frame5, height=2, width=6, text ='Neue\nStrecke', bd=5,\
            command = self.neuestrecke)
        self.neuestrecke.pack(side=LEFT)

        self.bloeschen = Button(self.frame5, height=2, width=6, text = "Löschen",bd=5,
            command = self.loeschen)
        self.bloeschen.pack(side=LEFT)

        self.bende = Button(self.frame5, height=2, width=4, text = "Ende", fg='red',bd=5,
            command = self.ende)
        self.bende.pack(side=LEFT)

        self.fenster.mainloop()

    def neuestrecke(self):
        self.tueber["text"] = ""
        self.y1.delete(0,END)
        self.y1.insert(0, "")
        self.x1.delete(0,END)
        self.x1.insert(0, "")
        self.y2.delete(0,END)
        self.y2.insert(0, "")
        self.x2.delete(0,END)
        self.x2.insert(0, "")
        self.strecke.delete(0,END)
        self.strecke.insert(0, "")

    def loeschen(self):
        self.fenster.destroy()
        self.__init__()

    def taste(self, event):
        if self.marke == 0:
            self.tueber["text"] = " \u26A0"
            self.tueber["fg"] = 'red'
        self.marke = 1
        self.brechnen["text"] = 'Erneut\nRechnen'

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'

    def ende(self):
        self.fenster.destroy()

    def rechnen(self):
        try:
            if self.strecke.get().strip():
                fstreckeutm = float(self.strecke.get())
                self.y1.delete(0,END)
                self.x1.delete(0,END)
                self.y2.delete(0,END)
                self.x2.delete(0,END)
            else:
                fy1 = float(self.y1.get())
                fx1 = float(self.x1.get())
                fy2 = float(self.y2.get())
                fx2 = float(self.x2.get())
                fstreckeutm = math.hypot(fy2 - fy1, fx2 - fx1)

            if not self.hoehe.get().strip():
                self.hoehe.insert(0, "100.0")
                fhoehe = 100.
            else:
                fhoehe = float(self.hoehe.get())
            fr = 6381. # Erdradius für NRW in [km]
            fhoehe +=  float(self.hoehe2.get())

            freduktion = 0.9996 *(1. + ((float(self.most.get()) - 500.)**2\
                 / (2.* fr * fr)) - (fhoehe * 0.001)/fr)

            fstreckewahr = fstreckeutm/freduktion

            self.brechnen["text"] = 'Rechnen'
            self.tueber["text"] = " \u2713"
            self.tueber["fg"] = 'limegreen'
            ausgabe = "Def.: Strecke (hor.) \u00D7 r = Strecke (UTM)"
            ausgabe += "\nReduktionsfaktor r = " + str(round(freduktion,7))
            ausgabe2 = "\nStrecke in UTM = " + str(round(fstreckeutm,3))
            ausgabe2 += "\n \u27F9 örtliche Streckenlänge = " + str(round(fstreckewahr,3))     
            self.lab2["text"] = ausgabe
            self.lab2["fg"] = "green"
            self.lab3["text"] = ausgabe2
            self.lab3["font"] ='Arial',10
            if self.fenster.bind('<KeyPress>',self.taste):
                self.marke = 0
        except:
            self.lab2["text"] = "Fehlerhafte Eingabe"
            self.lab2["fg"] = "red"
            self.warnzeichen()

# Ende class StreckeUTM()

#****************************************************************

class Bogenschnitt():  #12

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400. : t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------   
    def __init__(self):
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',11))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = "Bogenschnitt\n  Höhe- und Höhenfußpunkt ", fg='blue', font=('Arial',10))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack()
        self.tra = Label(self.frame2, text = 'Eingabe: Die Dreiecksseiten a,b,c oder\n die Koordinaten von A,B und die Seiten a,b ', font=('Arial',9))
        self.tra.pack
        self.tra.grid(column=0, columnspan=4, row=0,  pady=3)
        self.ta = Label(self.frame2, text ='A (y, x, a)', font=('Arial',10))
        self.ta.pack
        self.ta.grid(column=0, row=1)
        self.ya = Entry(self.frame2, width=8)
        self.ya.grid(column=1, row=1)
        self.ya.pack
     
        self.xa = Entry(self.frame2, width=8)
        self.xa.grid(column=2, row=1)
        self.xa.pack
        self.a = Entry(self.frame2, width=8)
        self.a.grid(column=3, row=1)
        self.a.focus()
        self.a.pack

        self.tb = Label(self.frame2, text ='B (y, x, b)', font=('Arial',10))
        self.tb.grid(column=0, row=3)
        self.tb.pack
        self.yb = Entry(self.frame2, width=8)
        self.yb.grid(column=1, row=3)
        self.yb.pack

        self.xb = Entry(self.frame2, width=8)
        self.xb.grid(column=2, row=3)
        self.xb.pack
        self.b = Entry(self.frame2, width=8)
        self.b.grid(column=3, row=3)
        self.b.pack

        self.tc = Label(self.frame2, text ='C (y, x, c)', font=('Arial',10))
        self.tc.pack
        self.tc.grid(column=0, row=4)
        self.yc = Entry(self.frame2, width=8, bg='Lightyellow')
        self.yc.grid(column=1, row=4)
        self.yc.pack
        self.xc = Entry(self.frame2, width=8, bg='Lightyellow')
        self.xc.grid(column=2, row=4)
        self.xc.pack
        self.c = Entry(self.frame2, width=8)
        self.c.grid(column=3, row=4)
        self.c.pack

        self.lab1 = Label(self.fenster, text = '', fg="black")
        self.lab1.pack()

        self.cx = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT) 
        self.rec = self.cx.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.cx.pack()

        self.lb = Label(self.fenster, text = "Ergebnis: ")
        self.lb.pack()

        self.cx = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.cx.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.cx.pack()
        
        self.frame3 = Frame(self.fenster, relief=FLAT, bd=5)
        self.frame3.pack()
        self.brechnen = Button(self.frame3, text = 'Rechnen', bd=5,
            command = self.dreieck)
        self.brechnen.pack(side=LEFT)

        self.bneu = Button(self.frame3, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame3, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(pady=4 ,side=LEFT, fill = X)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Bogenschnitt, Höhe- und Höhenfußpunkt")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v12.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv12.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.cx = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.cx.create_image(0, 0, anchor=NW, image=self.pic)
            self.cx.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v12.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def taste(self, event):
        if self.marke == 1:
            self.tueber["text"] = "\u26A0 "
            self.tueber["fg"] = 'red'
            self.marke = 0
        self.marke = 1
        self.brechnen["text"] = 'Erneut\nRechnen'

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0 "
        self.tueber["fg"] = 'red'

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def dreieck(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        self.tueber["text"] = " \u2713 "
        self.tueber["fg"] = 'limegreen'
        try:
            self.lb["fg"] = "black"
            fa  = float(self.a.get())
            fb  = float(self.b.get())
            if self.ya.get().strip() and self.xa.get().strip() and self.yb.get().strip() and self.xb.get().strip():
                self.bogenschnitt = TRUE
                fya = float(self.ya.get())
                fxa = float(self.xa.get())
                fyb = float(self.yb.get())
                fxb = float(self.xb.get())
                if fya == fyb and fxa == fxb :
                    self.lab1["text"] = "Fehler, Ausgangspunkte identisch!"
                    self.lab1["fg"] = "red"
                    self.warnzeichen()
                    return
                ftAB, fc = self.riwis(fyb - fya, fxb - fxa)
            elif self.a.get().strip() and self.b.get().strip() and self.c.get().strip():
                self.bogenschnitt = FALSE
                fc  = float(self.c.get())
            if fa > fb:
                fp = (fc * fc + fa * fa - fb * fb) / (2 * fc)
                fq = fc - fp
                fh = math.sqrt(fb * fb - fq * fq)
            else:
                fq = (fc * fc + fb * fb - fa * fa) / (2 * fc)
                fp = fc - fq
                fh = math.sqrt(fa * fa - fp * fp)
            alpha = math.atan2(fh, fq) * (200./math.pi)
            if alpha < 0.: alpha = 100. - alpha
            beta = math.atan2(fh, fp) * 200./math.pi
            if beta < 0.: beta = 100. - beta 
            gamma = 200. - alpha - beta
            flaeche = fh * fc /2
            lbtext =""
            self.xc.delete(0,END)
            self.yc.delete(0,END)
            if self.bogenschnitt == TRUE:
                ftAC = ftAB + alpha
                if ftAC >= 400.: ftAC -= 400.
                ftBC = ftAB + 200. - beta
                if ftBC < 0.: ftBC += 400.
                if ftBC == 0.: pass
                elif ftBC >= 400.: ftBC -= 400.
                fylot = fyb + (fya-fyb) * fp/fc
                fxlot = fxb + (fxa-fxb) * fp/fc
                fyc = fylot - (fxa-fxb) * fh/fc
                fxc = fxlot + (fya-fyb) * fh/fc
                self.c.delete(0,END)
                self.c.insert(0, str(round(fc,3)))
                self.yc.insert(0, str(round(fyc,3)))
                self.xc.insert(0, str(round(fxc,3)))
                self.lab1["text"] = "Richtungswinkel von B nach C = "  + str(round(ftBC,4))+ " gon" +\
                    "\nRichtungswinkel von A nach C = "  + str(round(ftAC,4))+ " gon"  +\
                    "\nRichtungswinkel von A nach B = " + str(round(ftAB,4))+ " gon"
                self.lab1["fg"] = "black"
                lbtext = "y (Lot) ={0:>8.3f}    x (Lot) ={1:>8.3f}".format(fylot,fxlot)
            if self.bogenschnitt == FALSE:
                self.ya.delete(0,END)
                self.xa.delete(0,END)
                self.yb.delete(0,END)
                self.xb.delete(0,END)
                self.lab1["text"] =""
            self.brechnen["text"] = 'Rechnen'

            self.lb["text"] =  lbtext + "\n     p ={0:>8.3f}    q ={1:>8.3f}   h ={2:>8.3f}    \n".format(fp,fq,fh) +\
                "     \u03B1 ={0:>9.4f} gon\n".format(alpha) + \
                "     \u03B2 ={0:>9.4f} gon\n".format(beta) + \
                "     \u03B3 ={0:>9.4f} gon\n".format(gamma) + \
                "   Fläche = {0:<8.2f}".format(flaeche)
        except:
            self.lb["text"] = "Bitte plausible Seiten eingeben."
            self.lb["fg"] = "red"
            self.warnzeichen()

#Ende class Bogenschnitt):

#****************************************************************

class Vorwaertsschnitt():  #13

    def riwis(self, dy, dx): #Fassung 22
        eps = 0.000001
        RHO = 63.66197723675812
        if abs(dy) < eps and abs (dx) < eps:
            return 0, 0
        if abs(dy) < abs (dx):
            t = RHO * math.atan(abs(dy/dx))
        else:
            t = 100. - (RHO * math.atan(abs(dx/dy)))
        if (dy > 0.) and (dx < 0.):
            t = 200.-t
        elif (dy <= 0.) and (dx < 0.):
            t += 200.
        elif (dy < 0.) and (dx >= 0.):
            t = 400.-t
        if t == 400. : t = 0.
        s = math.hypot(dy, dx)
        return t, s
#--------------------------------------------------------------------

    def tdja(self):
      self.bjad.configure(text="Ja")
      self.bjad.configure(bg="Lightgreen")
      self.winkel = 'd'
      self.bjar.configure(text="Nein")
      self.bjar.configure(bg="pink")
      self.taste
      self.warnzeichen()

    def trja(self):
      self.bjad.configure(text="Nein")
      self.bjad.configure(bg="pink")
      self.winkel = 'r'
      self.bjar.configure(text="Ja")
      self.bjar.configure(bg="Lightgreen")
      self.taste
      self.warnzeichen()

    def __init__(self):
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',11))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = "     Vorwärtsschnitt ", fg='blue', font=('Arial',10))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild)
        self.binfo.pack(side=RIGHT)

        self.frame2 = Frame(self.fenster, relief=RIDGE, bd=5)
        self.frame2.pack(pady=10)

        self.winkel = 'd'
        self.ltd = Label(self.frame2, text = '  über Dreieckswinkel', width=18, font=('Arial',9))
        self.ltd.grid(column=0, columnspan=3, row=0,  pady=10)
        self.ltd.pack

        self.bjad = Button(self.frame2, width=4, text = "Ja", bg = 'Lightgreen', bd=2,
                command = self.tdja)
        self.bjad.grid(column=3, row=0)
        self.bjad.pack
        self.ltr= Label(self.frame2, text = 'über Richtungswinkel', width = 18, font=('Arial',9))
        self.ltr.grid(column=0, columnspan=3, row=1, ipady=3)
        self.ltr.pack

        self.bjar = Button(self.frame2, width=4,text= "Nein", bg ="pink", bd=2,
                command = self.trja)
        self.bjar.grid(column=3, row=1, padx=0, pady=0)
        self.bjar.pack

        self.tsep = Label(self.frame2, text = '\u2500'*40, font=('Arial',4))
        self.tsep.grid(column=0, columnspan=4, row=2)
        self.tsep.pack

        self.tra = Label(self.frame2, text = '              y                   x            Winkel', font=('Arial',9))
        self.tra.pack
        self.tra.grid(column=0, columnspan=4, row=3,  pady=3)
        self.ta = Label(self.frame2, text =' A ', font=('Arial',10))
        self.ta.pack
        self.ta.grid(column=0, row=4)
        self.ya = Entry(self.frame2, width=10)
        self.ya.focus()
        self.ya.grid(column=1, row=4)

        self.ya.pack
        self.ya.focus_set() 
        self.xa = Entry(self.frame2, width=10)
        self.xa.grid(column=2, row=4)
        self.xa.insert(0,'0')
        self.xa.pack
        self.wa = Entry(self.frame2, width=9)
        self.wa.grid(column=3, row=4)
        self.wa.pack

        self.tb = Label(self.frame2, text =' B ', font=('Arial',10))
        self.tb.grid(column=0, row=5)
        self.tb.pack
        self.yb = Entry(self.frame2, width=10)
        self.yb.insert(0,'0')
        self.yb.grid(column=1, row=5)
        self.yb.pack
        
        self.xb = Entry(self.frame2, width=10)
        self.xb.grid(column=2, row=5)
        self.xb.insert(0,'0')
        self.xb.pack
        self.wb = Entry(self.frame2, width=9)
        self.wb.grid(column=3, row=5)
        self.wb.pack

        self.tc = Label(self.frame2, text =' C ', font=('Arial',10))
        self.tc.pack
        self.tc.grid(column=0, row=6)
        self.yc = Entry(self.frame2, width=10, bg='Lightyellow')
        self.yc.grid(column=1, row=6)
        self.yc.pack
        self.xc = Entry(self.frame2, width=10, bg='Lightyellow')
        self.xc.grid(column=2, row=6)
        self.xc.pack

        self.lab1 = Label(self.fenster, text = '', fg = "black")
        self.lab1.pack()

        self.cx = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT) 
        self.rec = self.cx.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'green')
        self.cx.pack()

        self.lab2  = Label(self.fenster, text = "Ergebnis:")
        self.lab2.pack()

        self.cx = Canvas(self.fenster, width='5.5c', height='0.3c', relief=FLAT)
        self.rec = self.cx.create_rectangle('0.4c','0c','5.5c','0.1c', outline = '', fill = 'blue')
        self.cx.pack()

        self.frame3 = Frame(self.fenster, relief=FLAT, bd=5)
        self.frame3.pack()
        self.brechnen = Button(self.frame3, width=7, height=2, text ='Rechnen', bd=5,
            command = self.dreieck)
        self.brechnen.pack(side=LEFT)

        self.bneu2= Button(self.frame3,  width=7, height=2, text ='Nächster\nSchnitt', bd=5,
            command = self.neu2)
        self.bneu2.pack(side=LEFT)

        self.bneu = Button(self.frame3, width=5 ,height=2, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame3, width=6, height=2, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(pady=4 ,side=LEFT, fill = X)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Vorwärtsschnitt")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:    
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v13.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv13.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.cx = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.cx.create_image(0, 0, anchor=NW, image=self.pic)
            self.cx.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v13.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()

    def neu2(self):
        self.yc.delete(0,END)
        self.xc.delete(0,END)
        self.wa.delete(0,END)
        self.wa.focus()
        self.wb.delete(0,END)
        self.warnzeichen()
        self.marke = 0

    def richtungsfehler(self): 
        if self.winkel == 'd':  # über Dreieckswinkel
            self.lab1["text"] = "Dreieckswinkel unplausibel"
        if self.winkel == 'r':  # über Richtungswinkel
            self.lab1["text"] = "Richtungen parallel, keine Lösung"
        self.lab1["fg"] = "red"
        self.lab2["text"] = ""
        self.warnzeichen()
        self.yc.delete(0,END)
        self.xc.delete(0,END)

    def taste(self, event):
        if self.marke == 1:
            self.tueber["text"] = "\u26A0 "
            self.tueber["fg"] = 'red'
            self.marke = 0
        self.marke = 1
        self.brechnen["text"] = 'Erneut\nRechnen'

    def warnzeichen(self):
        self.tueber["text"] = "\u26A0 "
        self.tueber["fg"] = 'red'

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def dreieck(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        self.tueber["text"] = " \u2713 "
        self.tueber["fg"] = 'limegreen'
        try:
            self.lab2["fg"] = "black"
            fya = float(self.ya.get())
            fxa = float(self.xa.get())
            fyb = float(self.yb.get())
            fxb = float(self.xb.get())
            if fya == fyb and fxa == fxb:
               self.lab1["text"] = "Fehler, Ausgangspunkte identisch!"
               self.lab1["fg"] = "red"
               self.warnzeichen()
               return
            ftAB, fc = self.riwis(fyb - fya, fxb - fxa)
            fwa  = float(self.wa.get())
            fwb  = float(self.wb.get())

            if self.winkel == 'd':  # über Dreieckswinkel
                if fwa <= 0. or fwb <= 0. or (fwa + fwb) >= 200.:
                    self.richtungsfehler()
                    return
                alpha = fwa
                beta = fwb
                gamma = 200. - alpha - beta
                fa = math.sin(math.pi*alpha/200.)*fc /math.sin(math.pi*gamma/200.)
                fb = math.sin(math.pi*beta/200.)*fc /math.sin(math.pi*gamma/200.)
                ftBC = ftAB - 200.- beta
                ftAC = ftAB + alpha
                if ftAC < 0.: ftAC += 400.
                if ftAC >= 400.: ftAC -= 400.
                if ftBC < 0.: ftBC += 400.
                if ftBC >= 400.: ftBC -= 400.
                fyc = fyb + fa * math.sin(math.pi*ftBC/200.)
                fxc = fxb + fa * math.cos(math.pi*ftBC/200.)

                fh = fa * math.sin(math.pi*beta/200.)
                fp = fa * math.cos(math.pi*beta/200.)
                fq =  fc - fp
                fylot = fya + fq * math.sin(math.pi*ftAB/200.)
                fxlot = fxa + fq * math.cos(math.pi*ftAB/200.)
                flaeche = fh * fc /2

            if self.winkel == 'r':  # über Richtungswinkel
                if abs(fwa - fwb)  < 0.0002 or abs(fwa - fwb - 200)< 0.0002  or abs(fwa - fwb + 200)< 0.0002:
                    self.richtungsfehler()
                    return
                ftAC = fwa
                ftBC = fwb
                if ftBC < 80 or ftBC > 320 or (ftBC > 120 and ftBC < 280):
                    fxc = fya - fyb + fxb*math.tan(math.pi*ftBC/200.) - fxa*math.tan(math.pi*ftAC/200.)
                    fxc = fxc /(math.tan(math.pi*ftBC/200.) - math.tan(math.pi*ftAC/200.))
                    fyc = fyb + (fxc-fxb)*math.tan(math.pi*ftBC/200.)
                else:
                    fyc = fxa - fxb + fyb*math.cot(math.pi*ftBC/200.) - fya*math.cot(math.pi*ftAC/200.)
                    fyc = fyc /(math.cot(math.pi*ftBC/200.) - math.cot(math.pi*ftAC/200.))
                    fxc = fxb + (fyc-fyb)*math.cot(math.pi*ftBC/200.)
                fa = math.hypot(fyc-fya, fxc-fxa)
                fb = math.hypot(fyc-fyb, fxc-fxb)
            self.yc.delete(0,END)
            self.xc.delete(0,END)
            self.yc.insert(0, str(round(fyc,3)))
            self.xc.insert(0, str(round(fxc,3)))
            self.lab1["text"] = "Richtungswinkel von B nach C = " + str(round(ftBC,4))+ " gon" + \
                "\nRichtungswinkel von A nach C = " + str(round(ftAC,4))+ " gon" + \
                "\nRichtungswinkel von A nach B = " + str(round(ftAB,4))+ " gon"
            self.lab1["fg"] = "black"

            self.brechnen["text"] = 'Rechnen'
            if self.winkel == 'd':  # über Dreieckswinkel
                self.lab2["text"] = "y (Lot) ={0:>8.3f}    x (Lot) ={1:>8.3f}".format(fylot,fxlot) + \
                                "\n     p ={0:>8.3f},    q ={1:>8.3f},   h ={2:>8.3f}    \n".format(fp,fq,fh) +\
                "a (von B nach C) = {0:>9.3f},".format(fa) + "  \u03B1 ={0:>9.4f} gon\n".format(alpha) + \
                "b (von A nach C) = {0:>9.3f},".format(fb) + "  \u03B2 ={0:>9.4f} gon\n".format(beta) + \
                "c (von A nach B) = {0:>9.3f},".format(fc) + "  \u03B3 ={0:>9.4f} gon\n".format(gamma) + \
                "   Fläche = {0:<8.2f}".format(flaeche)
            if self.winkel == 'r':  # über Richtungswinkel
                self.lab2["text"] = " Entfernung  a (von B nach C) = {0:>9.3f}\n".format(fa) + \
                " Entfernung  b (von A nach C) = {0:>9.3f}\n".format(fb) + \
                " Entfernung  c (von A nach B) = {0:>9.3f}".format(fc)
        except:
            self.lab2["text"] = "Bitte plausible Werte eingeben."
            self.lab2["fg"] = "red"
            self.warnzeichen()

#Ende class Vorwärtsschnitt():

#****************************************************************
         
class Pythagoras():  #14

    def __init__(self):
        self.marke = 0
        self.fenster = Tk()
        self.fenster.title("")
        if android == True:
            self.fenster.attributes('-fullscreen', True)
        self.frame = Frame(self.fenster)
        self.frame.pack()
        self.tueber = Label(self.frame, text = "", font=('Arial',12))
        self.tueber.pack(side = RIGHT)
        self.ueber = Label(self.frame, text = "  Pythagorasprobe  ", fg='blue', font=('Arial',12))
        self.ueber.pack(side = RIGHT)
        self.binfo = Button(self.frame, width=4, text ="  Grafik  ", bg ='white',relief=RIDGE, fg='darkgreen', bd=4, font=('Arial',10), height = 1,
        command = self.infobild) 
        self.binfo.pack(side=RIGHT)
        self.frame2 = Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack()

        self.ta = Label(self.frame2, text = ' Kathete a: ', font=('Arial',9))
        self.ta.grid(column=0, row=0)
        self.ta.pack
        self.a = Entry(self.frame2, width=10)
        self.a.grid(column=1, row=0)
        self.a.focus()
        self.a.pack

        self.tb = Label(self.frame2, text = ' Kathete b: ', font=('Arial',9))
        self.tb.grid(column=0, row=1 )
        self.tb.pack 
        self.b = Entry(self.frame2, width=10)
        self.b.grid(column=1, row=1, padx=4, pady=4)
        self.b.pack

        self.lb = Label(self.fenster, text = "Ergebnis: ")
        self.lb.pack()

        self.frame3 = Frame(self.fenster, relief=FLAT, bd=5)
        self.frame3.pack()

        self.brechnen= Button(self.frame3, text ='Rechnen', bd=5,
            command = self.pyth)
        self.brechnen.pack(side=LEFT)

        self.bneu = Button(self.frame3, text = "Neu", bd=5,
            command = self.neu)
        self.bneu.pack(side=LEFT)

        self.bende = Button(self.frame3, text = "Ende", fg='red', bd=5,
            command = self.ende)
        self.bende.pack(pady=4 ,side=LEFT)

        self.fenster.mainloop()

    def infodel(self):
        self.newWindow.destroy()
        self.binfo ["state"] = "normal"

    def infobild(self):
        try:
          if self.binfo["state"] == "normal":
            self.newWindow = Toplevel()
            self.newWindow.title(" Grafik ")
            self.newWindow.attributes("-topmost", 1)
            Label(self.newWindow, text =("Pythagorasprobe")).pack()
            try:
                current_dir = os.path.dirname(os.path.realpath(__file__))
            except:
                current_dir = os.path.abspath(sys.argv[0])
            if android == True:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/v14.png"
            else:
                path_file= os.path.dirname(os.path.realpath(__file__))+ "/vv14.png"
            Label(self.newWindow, text =(path_file)).pack()
            self.pic = PhotoImage(file= path_file)
            self.c = Canvas(self.newWindow, width=self.pic.width(),
                        height=self.pic.height())
            self.c.create_image(0, 0, anchor=NW, image=self.pic)
            self.c.pack()
            self.bende = Button(self.newWindow, text = "\u2573   Grafik  schließen", fg='white', bg='red', bd=2, relief=GROOVE, #relief=FLAT,
                command = self.infodel)
            self.bende.pack()
            self.binfo["state"] = "disabled"
            self.newWindow.mainloop()
          else:
            if self.binfo["state"] == "disabled":
              return
        except:
            tkinter.messagebox.showerror("Fehlermeldung","Die Grafikdatei <v13.png>\n ist nicht vorhanden.")

    def neu(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()
        self.__init__()
        
    def warnzeichen(self):
        self.tueber["text"] = "\u26A0"
        self.tueber["fg"] = 'red'
        
    def taste(self, event):
        if self.marke == 1:
            self.warnzeichen()
        self.marke = 0
        self.brechnen["text"] = 'Erneut\nRechnen'

    def ende(self):
        try:
          self.newWindow.destroy()
        except: pass
        self.fenster.destroy()

    def pyth(self):
        if self.fenster.bind('<KeyPress>',self.taste):
            self.marke = 1
        self.tueber["text"] = " \u2713"
        self.tueber["fg"] = 'limegreen'
        try:
            fa = float(self.a.get())
            fb = float(self.b.get())
            fc = math.hypot(fa,fb)
            alpha = 200. * math.asin(fa/fc)/math.pi
            beta = 100. - alpha

            self.brechnen["text"] = 'Rechnen'
            self.lb["text"] = "gerechnete Hypotenuse = " + str(round(fc, 3)) +\
             "\n Fläche = " + str(round(fa*fb/2, 2)) + "\n\u03B1 = " +\
             str(round(alpha, 4)) +  " gon\n\u03B2 = " + str(round(beta, 4)) + " gon"
            self.lb["fg"] = "black"
        except:
            self.lb["text"] = "Bitte Kathetenlängen eingeben."
            self.lb["fg"] = "red"
            self.warnzeichen()
        
# Ende class Pythagoras():

#****************************************************************

class Menu():
    def __init__(self):
        fenster = Tk()
        fenster.title("1.01")
        fenster.geometry("230x500")

        try:
            path_file1= os.path.dirname(os.path.realpath(__file__))+ "/v10.png"
            photo1 = PhotoImage(file = path_file1)
            fenster.iconphoto(False, photo1)

            titel=Label(master=fenster, text="Vermessungstechnische\n Berechnungen",
            font=('Arial',11), width=25, fg='blue')

            path_file2= os.path.dirname(os.path.realpath(__file__))+ "/v11.png"
            photo2 = PhotoImage(file = path_file2)
            fenster.iconphoto(True, photo2)

        except:
            tkinter.messagebox.showerror("Vermessungstechnische Berechnungen","Fehlermeldung\nDie Grafikdateien <v10.png> oder <v11.png>\nsind nicht vorhanden.")
            fenster.destroy()
            sys.exit()

        quitt= Button(fenster, width=36, borderwidth=3, text="Programm schließen", fg='red', command=fenster.destroy)
        ortho= Button(fenster, width=36, borderwidth=3, text="Orthogonale und polare Elemente", command=Ortho)
        polarg= Button(fenster, width=36, borderwidth=3, text=" Polaraufnahme (lokale Geradlinigkeit) ", command=PolaraufnahmeGerade)
        polara= Button(fenster, width=36, borderwidth=3, text="Polaraufnahme (Koordinaten)" , command=Polaraufnahme)
        trans= Button(fenster, width=36, borderwidth=3, text="Transformation, Kleinpunkte", command=Transformation)
        gerade= Button(fenster, width=36, borderwidth=3, text="Geradenschnitte", command=Geradenschnitte)
        kreisgerade= Button(fenster, width=36, borderwidth=3, text="Kreis-Geraden-Schnitt", command=KreisGerade)
        kreis= Button(fenster, width=36, borderwidth=3, text="Kreisbogenteilung", command=Kreisbogen)
        flaeche= Button(fenster, width=36, borderwidth=3, text="Flächenberechnung", command=Flaeche)
        polygon= Button(fenster, width=36, borderwidth=3, text="Polygonzug", command=Polygonzug)
        streckenreduktion=Button(fenster, width=36, borderwidth=3, text="Streckenreduktion örtlich \u27F9 UTM", command=Streckenreduktion)
        utm=Button(fenster, width=36, borderwidth=3, text="Strecke UTM \u27F9 örtlich", command=StreckeUTM)
        bogenschnitt= Button(fenster, width=36, borderwidth=3, text="Bogenschnitt, Höhe und Höhenfußpunkt", command=Bogenschnitt)
        vorwaertsschnitt= Button(fenster, width=36, borderwidth=3, text="Vorwärtsschnitt ", command=Vorwaertsschnitt)
        pythagoras= Button(fenster, width=36, borderwidth=3, text="Pythagorasprobe", command=Pythagoras)

        titel.pack(pady=2)
        quitt.pack()
        ortho.pack()
        polarg.pack()
        polara.pack()
        trans.pack()
        gerade.pack()
        kreisgerade.pack()
        kreis.pack()
        flaeche.pack()
        polygon.pack()
        streckenreduktion.pack()
        utm.pack()
        bogenschnitt.pack()
        vorwaertsschnitt.pack()
        pythagoras.pack()
        text1 = Label(fenster, text = '\u00A9 2023 Norbert Fuhrmann, Kerpen\nwww.grenzuntersuchung.de', fg='blue', font=('Arial',8))
        text1.pack()

        fenster.mainloop()

i= Menu()

